package ConfigAnalyzer;
use strict;
# Version 0.1.2a, 15th Aug 2005

# License: This script & the Perl-Module are published under the GPL:

# This Software is copyright by Dror-John Roecher, 2005
# The author can be reached via mail: droecher@ernw.de
# There is no warranty that the software works, produces something useful,
# or wont break your system.
#
# This software is protected by the GNU General Public License
#
#
#		    GNU GENERAL PUBLIC LICENSE
#		       Version 2, June 1991
#
# Copyright (C) 1989, 1991 Free Software Foundation, Inc.
#                       51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
# Everyone is permitted to copy and distribute verbatim copies
# of this license document, but changing it is not allowed.
#
#			    Preamble
#
#  The licenses for most software are designed to take away your
#freedom to share and change it.  By contrast, the GNU General Public
#License is intended to guarantee your freedom to share and change free
#software--to make sure the software is free for all its users.  This
#General Public License applies to most of the Free Software
#Foundation's software and to any other program whose authors commit to
#using it.  (Some other Free Software Foundation software is covered by
#the GNU Library General Public License instead.)  You can apply it to
#your programs, too.
#
#  When we speak of free software, we are referring to freedom, not
#price.  Our General Public Licenses are designed to make sure that you
#have the freedom to distribute copies of free software (and charge for
#this service if you wish), that you receive source code or can get it
#if you want it, that you can change the software or use pieces of it
#in new free programs; and that you know you can do these things.
#
#  To protect your rights, we need to make restrictions that forbid
#anyone to deny you these rights or to ask you to surrender the rights.
#These restrictions translate to certain responsibilities for you if you
#distribute copies of the software, or if you modify it.
#
#  For example, if you distribute copies of such a program, whether
#gratis or for a fee, you must give the recipients all the rights that
#you have.  You must make sure that they, too, receive or can get the
#source code.  And you must show them these terms so they know their
#rights.
#
#  We protect your rights with two steps: (1) copyright the software, and
#(2) offer you this license which gives you legal permission to copy,
#distribute and/or modify the software.
#
#  Also, for each author's protection and ours, we want to make certain
#that everyone understands that there is no warranty for this free
#software.  If the software is modified by someone else and passed on, we
#want its recipients to know that what they have is not the original, so
#that any problems introduced by others will not reflect on the original
#authors' reputations.
#
#  Finally, any free program is threatened constantly by software
#patents.  We wish to avoid the danger that redistributors of a free
#program will individually obtain patent licenses, in effect making the
#program proprietary.  To prevent this, we have made it clear that any
#patent must be licensed for everyone's free use or not licensed at all.
#
#  The precise terms and conditions for copying, distribution and
#modification follow.
#
#		    GNU GENERAL PUBLIC LICENSE
#   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
#
#  0. This License applies to any program or other work which contains
#a notice placed by the copyright holder saying it may be distributed
#under the terms of this General Public License.  The "Program", below,
#refers to any such program or work, and a "work based on the Program"
#means either the Program or any derivative work under copyright law:
#that is to say, a work containing the Program or a portion of it,
#either verbatim or with modifications and/or translated into another
#language.  (Hereinafter, translation is included without limitation in
#the term "modification".)  Each licensee is addressed as "you".
#
#Activities other than copying, distribution and modification are not
#covered by this License; they are outside its scope.  The act of
#running the Program is not restricted, and the output from the Program
#is covered only if its contents constitute a work based on the
#Program (independent of having been made by running the Program).
#Whether that is true depends on what the Program does.
#
#  1. You may copy and distribute verbatim copies of the Program's
#source code as you receive it, in any medium, provided that you
#conspicuously and appropriately publish on each copy an appropriate
#copyright notice and disclaimer of warranty; keep intact all the
#notices that refer to this License and to the absence of any warranty;
#and give any other recipients of the Program a copy of this License
#along with the Program.
#
#You may charge a fee for the physical act of transferring a copy, and
#you may at your option offer warranty protection in exchange for a fee.
#
#  2. You may modify your copy or copies of the Program or any portion
#of it, thus forming a work based on the Program, and copy and
#distribute such modifications or work under the terms of Section 1
#above, provided that you also meet all of these conditions:
#
#    a) You must cause the modified files to carry prominent notices
#    stating that you changed the files and the date of any change.
#
#    b) You must cause any work that you distribute or publish, that in
#    whole or in part contains or is derived from the Program or any
#    part thereof, to be licensed as a whole at no charge to all third
#    parties under the terms of this License.
#
#    c) If the modified program normally reads commands interactively
#    when run, you must cause it, when started running for such
#    interactive use in the most ordinary way, to print or display an
#    announcement including an appropriate copyright notice and a
#    notice that there is no warranty (or else, saying that you provide
#    a warranty) and that users may redistribute the program under
#    these conditions, and telling the user how to view a copy of this
#    License.  (Exception: if the Program itself is interactive but
#    does not normally print such an announcement, your work based on
#    the Program is not required to print an announcement.)
#
#These requirements apply to the modified work as a whole.  If
#identifiable sections of that work are not derived from the Program,
#and can be reasonably considered independent and separate works in
#themselves, then this License, and its terms, do not apply to those
#sections when you distribute them as separate works.  But when you
#distribute the same sections as part of a whole which is a work based
#on the Program, the distribution of the whole must be on the terms of
#this License, whose permissions for other licensees extend to the
#entire whole, and thus to each and every part regardless of who wrote it.
#
#Thus, it is not the intent of this section to claim rights or contest
#your rights to work written entirely by you; rather, the intent is to
#exercise the right to control the distribution of derivative or
#collective works based on the Program.
#
#In addition, mere aggregation of another work not based on the Program
#with the Program (or with a work based on the Program) on a volume of
#a storage or distribution medium does not bring the other work under
#the scope of this License.
#
#  3. You may copy and distribute the Program (or a work based on it,
#under Section 2) in object code or executable form under the terms of
#Sections 1 and 2 above provided that you also do one of the following:
#
#    a) Accompany it with the complete corresponding machine-readable
#    source code, which must be distributed under the terms of Sections
#    1 and 2 above on a medium customarily used for software interchange; or,
#
#    b) Accompany it with a written offer, valid for at least three
#    years, to give any third party, for a charge no more than your
#    cost of physically performing source distribution, a complete
#    machine-readable copy of the corresponding source code, to be
#    distributed under the terms of Sections 1 and 2 above on a medium
#    customarily used for software interchange; or,
#
#    c) Accompany it with the information you received as to the offer
#    to distribute corresponding source code.  (This alternative is
#    allowed only for noncommercial distribution and only if you
#    received the program in object code or executable form with such
#    an offer, in accord with Subsection b above.)
#
#The source code for a work means the preferred form of the work for
#making modifications to it.  For an executable work, complete source
#code means all the source code for all modules it contains, plus any
#associated interface definition files, plus the scripts used to
#control compilation and installation of the executable.  However, as a
#special exception, the source code distributed need not include
#anything that is normally distributed (in either source or binary
#form) with the major components (compiler, kernel, and so on) of the
#operating system on which the executable runs, unless that component
#itself accompanies the executable.
#
#If distribution of executable or object code is made by offering
#access to copy from a designated place, then offering equivalent
#access to copy the source code from the same place counts as
#distribution of the source code, even though third parties are not
#compelled to copy the source along with the object code.
#
#  4. You may not copy, modify, sublicense, or distribute the Program
#except as expressly provided under this License.  Any attempt
#otherwise to copy, modify, sublicense or distribute the Program is
#void, and will automatically terminate your rights under this License.
#However, parties who have received copies, or rights, from you under
#this License will not have their licenses terminated so long as such
#parties remain in full compliance.
#
#  5. You are not required to accept this License, since you have not
#signed it.  However, nothing else grants you permission to modify or
#distribute the Program or its derivative works.  These actions are
#prohibited by law if you do not accept this License.  Therefore, by
#modifying or distributing the Program (or any work based on the
#Program), you indicate your acceptance of this License to do so, and
#all its terms and conditions for copying, distributing or modifying
#the Program or works based on it.
#
#  6. Each time you redistribute the Program (or any work based on the
#Program), the recipient automatically receives a license from the
#original licensor to copy, distribute or modify the Program subject to
#these terms and conditions.  You may not impose any further
#restrictions on the recipients' exercise of the rights granted herein.
#You are not responsible for enforcing compliance by third parties to
#this License.
#
#  7. If, as a consequence of a court judgment or allegation of patent
#infringement or for any other reason (not limited to patent issues),
#conditions are imposed on you (whether by court order, agreement or
#otherwise) that contradict the conditions of this License, they do not
#excuse you from the conditions of this License.  If you cannot
#distribute so as to satisfy simultaneously your obligations under this
#License and any other pertinent obligations, then as a consequence you
#may not distribute the Program at all.  For example, if a patent
#license would not permit royalty-free redistribution of the Program by
#all those who receive copies directly or indirectly through you, then
#the only way you could satisfy both it and this License would be to
#refrain entirely from distribution of the Program.
#
#If any portion of this section is held invalid or unenforceable under
#any particular circumstance, the balance of the section is intended to
#apply and the section as a whole is intended to apply in other
#circumstances.
#
#It is not the purpose of this section to induce you to infringe any
#patents or other property right claims or to contest validity of any
#such claims; this section has the sole purpose of protecting the
#integrity of the free software distribution system, which is
#implemented by public license practices.  Many people have made
#generous contributions to the wide range of software distributed
#through that system in reliance on consistent application of that
#system; it is up to the author/donor to decide if he or she is willing
#to distribute software through any other system and a licensee cannot
#impose that choice.
#
#This section is intended to make thoroughly clear what is believed to
#be a consequence of the rest of this License.
#
#  8. If the distribution and/or use of the Program is restricted in
#certain countries either by patents or by copyrighted interfaces, the
#original copyright holder who places the Program under this License
#may add an explicit geographical distribution limitation excluding
#those countries, so that distribution is permitted only in or among
#countries not thus excluded.  In such case, this License incorporates
#the limitation as if written in the body of this License.
#
#  9. The Free Software Foundation may publish revised and/or new versions
#of the General Public License from time to time.  Such new versions will
#be similar in spirit to the present version, but may differ in detail to
#address new problems or concerns.
#
#Each version is given a distinguishing version number.  If the Program
#specifies a version number of this License which applies to it and "any
#later version", you have the option of following the terms and conditions
#either of that version or of any later version published by the Free
#Software Foundation.  If the Program does not specify a version number of
#this License, you may choose any version ever published by the Free Software
#Foundation.
#
#  10. If you wish to incorporate parts of the Program into other free
#programs whose distribution conditions are different, write to the author
#to ask for permission.  For software which is copyrighted by the Free
#Software Foundation, write to the Free Software Foundation; we sometimes
#make exceptions for this.  Our decision will be guided by the two goals
#of preserving the free status of all derivatives of our free software and
#of promoting the sharing and reuse of software generally.
#
#			    NO WARRANTY
#
#  11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
#FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
#OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
#PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
#OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
#TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
#PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
#REPAIR OR CORRECTION.
#
#  12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
#WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
#REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
#INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
#OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
#TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
#YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
#PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
#POSSIBILITY OF SUCH DAMAGES.
#
#		     END OF TERMS AND CONDITIONS
#
#	    How to Apply These Terms to Your New Programs
#
#  If you develop a new program, and you want it to be of the greatest
#possible use to the public, the best way to achieve this is to make it
#free software which everyone can redistribute and change under these terms.
#
#  To do so, attach the following notices to the program.  It is safest
#to attach them to the start of each source file to most effectively
#convey the exclusion of warranty; and each file should have at least
#the "copyright" line and a pointer to where the full notice is found.
#
#    <one line to give the program's name and a brief idea of what it does.>
#    Copyright (C) <year>  <name of author>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
#
#Also add information on how to contact you by electronic and paper mail.
#
#If the program is interactive, make it output a short notice like this
#when it starts in an interactive mode:
#
#    Gnomovision version 69, Copyright (C) year name of author
#    Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
#    This is free software, and you are welcome to redistribute it
#    under certain conditions; type `show c' for details.
#
#The hypothetical commands `show w' and `show c' should show the appropriate
#parts of the General Public License.  Of course, the commands you use may
#be called something other than `show w' and `show c'; they could even be
#mouse-clicks or menu items--whatever suits your program.
#
#You should also get your employer (if you work as a programmer) or your
#school, if any, to sign a "copyright disclaimer" for the program, if
#necessary.  Here is a sample; alter the names:
#
#  Yoyodyne, Inc., hereby disclaims all copyright interest in the program
#  `Gnomovision' (which makes passes at compilers) written by James Hacker.
#
#  <signature of Ty Coon>, 1 April 1989
#  Ty Coon, President of Vice
#
#This General Public License does not permit incorporating your program into
#proprietary programs.  If your program is a subroutine library, you may
#consider it more useful to permit linking proprietary applications with the
#library.  If this is what you want to do, use the GNU Library General
#Public License instead of this License.




sub new {
  my $class = shift;
  my $self = bless {}, $class;
  return $self;
}






sub ReadOption($;$;$) { # $basedir; $optionsfile; $verbose=[1|0] -> returns a hash with "where the testsections are in the optionsfile"
    
    # Argumenthandling
    my $basedir=$_[1];
    my $optionsfile=$_[2];
    my $verbose=$_[3];
    
    my $optionsfilename = $basedir . "\\" . $optionsfile;
    
    # known sections
    my @sect_services;            #element [0] holds startline and [1] holds lastline of options-section
    my @sect_dns;                 #element [0] holds startline and [1] holds lastline of options-section
    my @sect_syslog;              #element [0] holds startline and [1] holds lastline of options-section
    my @sect_l2if;                #element [0] holds startline and [1] holds lastline of options-section
    my @sect_snmp;                #element [0] holds startline and [1] holds lastline of options-section
    my @sect_aaa_authentication;  #element [0] holds startline and [1] holds lastline of options-section
    my @sect_aaa_authorization;   #element [0] holds startline and [1] holds lastline of options-section
    my @sect_aaa_accounting;      #element [0] holds startline and [1] holds lastline of options-section
    my @sect_aaa_general;         #element [0] holds startline and [1] holds lastline of options-section
    my $lastline = 0;             # counter of the last configline
    
    
    
    my $testsnmp=0;     # will be set to "1" if a section for that test was found
    my $testl2if=0;
    my $testsyslog=0;
    my $testdns=0;
    my $testservices=0;
    my $testaaa_authentication=0;
    my $testaaa_authorization=0;
    my $testaaa_accounting=0;
    my $testaaa_general=0;
    
    
    my $testcounter=0;  # this will hold the number of testsections found in the options-file
    my @sorted;
    my @options;        # used to store the config file
    
    {                   # Reads the Optionsfile and puts the contents in @options
        #my $optionsfilename = "$_[0]\\$_[1]";
        my $linecounter = 0;
        
        open(my $FH,$optionsfilename) or die "cant find $optionsfilename";
        while (<$FH>) {
            
            chomp;                                  # remove newlines
            $options[$linecounter]=$_;              # put current line in @options and number it 
            if (m/^\[services\]/) {                 # check if line is the start of section "services
                $sect_services[0]=$linecounter;         # store the startlinenumber 
                $testcounter++;                         # add 1 to the number of testsections found
                $testservices = 1;                      # mark that we will test the services section
                
            }
            elsif (m/^\[dns\]/) {
                $sect_dns[0]=$linecounter;
                $testcounter++;
                $testdns = 1;
                
            }
            elsif (m/^\[syslog\]/) {
                $sect_syslog[0]=$linecounter;
                $testcounter++;
                $testsyslog = 1;
                
            }
            elsif (m/^\[snmp\]/) {
                $sect_snmp[0]=$linecounter;
                $testcounter++;
                $testsnmp = 1;
                
            }
            elsif (m/^\[layer2-interface\]/) {
                $sect_l2if[0]=$linecounter;
                $testcounter++,
                $testl2if = 1;
                
            }
            
            elsif (m/^\[AAA-General\]/) {
              $sect_aaa_general[0]=$linecounter;
              $testcounter++;
              $testaaa_general = 1;
            }
            
            elsif (m/^\[AAA-Authentication\]/) {
              $sect_aaa_authentication[0]=$linecounter;
              $testcounter++;
              $testaaa_authentication = 1;
            }

            elsif (m/^\[AAA-Authorization\]/) {
              $sect_aaa_authorization[0]=$linecounter;
              $testcounter++;
              $testaaa_authorization = 1;
            }

            elsif (m/^\[AAA-Accounting\]/) {
              $sect_aaa_accounting[0]=$linecounter;
              $testcounter++;
              $testaaa_accounting = 1;
            }
	    
                                        
            elsif (m/^\[end\]/) {
                $lastline = $linecounter;
                
            }
            
            else {
                #failsafe
            }
            
            
            $linecounter++;                         # add 1 to the linecounter and return to top to read next line
            
        }
        
        
        close $FH;                                  # cleaning up behind me, after the file has been read
    }   
    #print @options; 
    
    if ($testcounter==0) {die ("No Testsections found in options-file, will abort!\n");}
    
    else {
        @sorted = sort {$a <=> $b}($sect_l2if[0],
                                   $sect_snmp[0],
                                   $sect_syslog[0],
                                   $sect_dns[0],
                                   $sect_services[0],
                                   $sect_aaa_general[0],
                                   $sect_aaa_authentication[0],
                                   $sect_aaa_authorization[0],
                                   $sect_aaa_accounting[0],
                                   $lastline
                                   );
           
    }
    
    for (my $i=0;$i < $testcounter;$i++) {      # find the endline of each testsection
        
        
        if ($sect_l2if[0] == $sorted[$i]) {
            $sect_l2if[1] = $sorted[$i+1]-$sorted[$i] + $sect_l2if[0]-1;
        }
        elsif ($sect_snmp[0] == $sorted[$i]) {
            $sect_snmp[1] = $sorted[$i+1]-$sorted[$i] + $sect_snmp[0]-1;
        }
        elsif ($sect_syslog[0] == $sorted[$i]) {
            $sect_syslog[1] = $sorted[$i+1]-$sorted[$i] + $sect_syslog[0]-1;
        }
        elsif ($sect_dns[0] == $sorted[$i]) {
            $sect_dns[1] = $sorted[$i+1]-$sorted[$i] + $sect_dns[0]-1;
        }
        elsif ($sect_services[0] == $sorted[$i]) {
            $sect_services[1] = $sorted[$i+1]-$sorted[$i] + $sect_services[0]-1;
        }
        elsif ($sect_aaa_authentication[0] == $sorted[$i]) {
            $sect_aaa_authentication[1] = $sorted[$i+1]-$sorted[$i] + $sect_aaa_authentication[0]-1;
        }
        elsif ($sect_aaa_authorization[0] == $sorted[$i]) {
            $sect_aaa_authorization[1] = $sorted[$i+1]-$sorted[$i] + $sect_aaa_authorization[0]-1;
        }

        elsif ($sect_aaa_accounting[0] == $sorted[$i]) {
            $sect_aaa_accounting[1] = $sorted[$i+1]-$sorted[$i] + $sect_aaa_accounting[0]-1;
        }
        elsif ($sect_aaa_general[0] == $sorted[$i]) {
            $sect_aaa_general[1] = $sorted[$i+1]-$sorted[$i] + $sect_aaa_general[0]-1;
        }
        else {
            # failsafe
        }
        
           
    }
    
    my %returnhash = (
                      snmp_start     =>    $sect_snmp[0],
                      snmp_end       =>    $sect_snmp[1],
                      l2if_start     =>    $sect_l2if[0],
                      l2if_end       =>    $sect_l2if[1],
                      syslog_start   =>    $sect_syslog[0],
                      syslog_end     =>    $sect_syslog[1],
                      services_start =>    $sect_services[0],
                      services_end   =>    $sect_services[1],
                      dns_start      =>    $sect_dns[0],
                      dns_end        =>    $sect_dns[1],
                      aaa_authentication_start     =>    $sect_aaa_authentication[0],
                      aaa_authentication_end       =>    $sect_aaa_authentication[1],
                      aaa_authorization_start      =>    $sect_aaa_authorization[0],
                      aaa_authorization_end        =>    $sect_aaa_authorization[1],
                      aaa_accounting_start         =>    $sect_aaa_accounting[0],
                      aaa_accounting_end           =>    $sect_aaa_accounting[1],
                      aaa_general_start            =>    $sect_aaa_general[0],
                      aaa_general_end              =>    $sect_aaa_general[1],
                     );
    
    #@sect_l2if, @sect_snmp, @sect_syslog, @sect_services, @sect_dns, $testsnmp, $testl2if, $testsyslog, $testdns, $testservices
    
    if ($verbose == 1) {
      print "********** Analysis of testconfigfile sections: ************* \n";
      while ( my ($key, $value) = each(%returnhash) ) {
        print "$key => $value\n";
      }
    }

    
    return(%returnhash);


}

sub getFileLines($;$;$;$) { #get $startline to $endline of $file; $verbose, to be called by Subs
                          # returns @lines with the lines from the file  
  
  my $firstline = $_[1];  #handle arguments
  my $lastline  = $_[2];
  my $filename  = $_[3];
  my $verbose   = $_[4];
  
  my $linecounter=0;
  my @tempcontents;
  my @returnlines;
  
  open(my $FH,$filename) or die "cant find $filename";
  while (<$FH>) {
            #chomp;                                  # remove newlines
            $tempcontents[$linecounter] = $_;
            $linecounter++;
  }
  close $FH;
  
  $linecounter=0;
  if ($verbose == 1) {
    print "********** Getting part of the test-configuration file ***********\n";
  }
  for (my $i=$firstline;$i<=$lastline;$i++) {
    $returnlines[$linecounter] = $tempcontents[$i];
    if ($verbose == 1) {
      print "$returnlines[$linecounter]\n";
    }
    
    $linecounter++;
  }
  
  return(@returnlines);
  
}












sub testDNS(@;@;$) { # @switchconfig; @dns-test-config; $verbose=[1|0]
  
}



sub testSNMP(@;@;$) { # @switchconfig; @dns-test-config; $verbose=[1|0]
  
}




sub testSyslog(\@;\@;$) { # @switchconfig; @syslog-tests; $verbose=[1|0]
  my ($config, $testsection, $verbose) = ($_[1],$_[2],$_[3]);
  #my %syslogresult;
  
  #print @$config;
  #print @$testsection;
  
  # Long block of variables needed for testing...
  # usually devided into three parts:
  # what is the value defined in the test-file?
  # what is the value defined in the switch-file?
  # do we test for it?
  #
  
  my $checksylogservers=0;           # 0 if not to test for existance of syslog-servers, 1 otherwise. Depends on the number of syslog servers defined in the test-file (e.g. is there a server defined, than test it in the config)
  my @testsyslogservers = {};                # holding all syslog-servers from testfile
  my @configsyslogservers ={};
  my $testsyslogservercount = 0;         # number syslogservers defined in test-files
  my $configsyslogservercount = 0;       # numbers of syslog servers in switchfile-file
  
  
  my $checkhost=0;                        # O if not to test host statement, 1 otherwise
  my @confighost={};               # holding all extended host-statements from config-file 
  my $testhostcount=0;             # number of host statements in test-file
  my $confighostcount=0;
  my @testhostservers = {};              # holding all extended host-statements from testfile
  
  my $checkbuffer = 0;              # "0" if not to test logging buffered, 1 if logging buffered is to be tested
  my $testsyslogbuffersize=0;            # Size of buffer defined in test-file
  my $testbufferlevel = "none";          # level of logging to local buffer in test-file
  my $configbuffersize=0;                # Size of buffer defined in the switch-config
  my $configbufferlevel="none";                 # level of logging to local buffer in switch-config
  
  my $checktrap=0;                        # O if not to test for traps, 1 otherwise
  my $testtraplevel="none";              # Traplevel in test-file
  my $configtraplevel="none";                 # Traplevel in switch config
  
  
  my $checkconsole=0;                     # O if not to test for console logging, 1 otherwise
  my $testconsolelevel="none";           # Console Logginglevel
  my $configconsolelevel="none";         # level of logging to console in switch-config
  
  
  my $checksource=0;                      # O if not to test for console logging, 1 otherwise
  my $testsourceif="none";               # source interface for syslog
  my $configsourceif="none";
  
  
  my $checkfacility = 0;                  # O if not to test facility, 1 otherwise
  my $testdefinedfacility="none";        # which facility is given in test-file
  my $configdefinedfacility="none";      # the facility defined in the config
  
  
  my $checkmonitor = 0;                   # do we test for monitor statements?
  my $testmonitorlevel="none";           # monitor logging level from test-file
  my $configmonitorlevel="none";         # monitor logging level from config-file
  
  
  my $checkexception=0;                   # do we test for exception
  my $testexception="disabled";         # is exception testing defined in test-file?
  my $testexceptionsize=0;               # what is the exception size in the testfile
  my $configexception=0;                 # is exception present in config-file?
  my $configexceptionsize=0;             # what is the size of the exception in the config file?
  
  my $checkhistory=0;
  my $testhistorylevel="none";
  my $testhistorysize=0;
  my $confighistorylevel="none";
  my $confighistorysize=0;
  
  my $checkorigin=0;
  my $testorigintype="none";
  my $testoriginstring="none";
  my $configorigintype="none";
  my $configoriginstring="none";
  
  my $checkratelimit=0;
  my $testratelimittype="none";
  my $testratelimitmps=0;
  my $testratelimitexcept="none";
  my $configratelimittype="none";
  my $configratelimitmps=0;
  my $configratelimitexcept="none";
  
  my $configlogenabled=1;
  
  my $testlinecount=0;                       # is counting of syslog-lines enabled in test-file?
  my $checklinecount=0;                       # is counting of syslog-lines enabled in test-file?
  my $configlinecount=0;                       # is counting of syslog-lines enabled in test-file?
  
  
  # analyze the Testsection
  foreach my $line (@$testsection) {
    
    # find rate-limit type in test-file (console | all | excepted)
    if ($line =~ m/^rate-limit-type/) {
      $checkratelimit = 1;
      chomp $line;
      my @temp = split(/=/,$line);
      $testratelimittype=$temp[1];
    }
    
    #find rate-limit messages-per-second (mps) in test-file
    if ($line =~ m/^rate-limit-mps/) {
      chomp $line;
      my @temp = split(/=/,$line);
      $testratelimitmps=$temp[1];
    }
    
    # find rate-limit exception in test-file
    if ($line =~ m/^rate-limit-exception/) {
      chomp $line;
      my @temp = split(/=/,$line);
      $testratelimitexcept=$temp[1];
    }

    
    # find origin-id string in testfile
    if ($line =~ m/^origin-id/) {
      $checkorigin=1;
      chomp $line;
      my @temp = split(/=/,$line);
      $testorigintype=$temp[1];
    }
    
    # find origin-string in testfile if origin-id ist of type string
    if ($testorigintype eq "string") {
      if ($line =~ m/^origin-string/) {
        chomp $line;
        my @temp = split(/=/,$line);
        $testoriginstring = $temp[1];
      }
    }
    
    # is history logging in test-file?
    if (($line =~ m/^historysize/) || ($line =~ m/^historylevel/)) {$checkhistory=1;}
    
    # find history size in testfile
    if ($line =~ m/^historysize/) {
      chomp $line;
      my @temp = split(/=/,$line);
      $testhistorysize=$temp[1];
    }
    
    # find historylevel in testfile
    if ($line =~ m/^historylevel/) {
      chomp $line;
      my @temp = split(/=/,$line);
      $testhistorylevel=$temp[1];
    }
    
    # is exception enabled?
    if ($line =~ m/^exception=/) {
      chomp $line;
      my @temp = split(/=/,$line);
      $testexception = $temp[1];
      if ($testexception eq "enabled") {$checkexception=1}
    }
    
    # find exception size in test-file
    if ($line =~ m/^exceptionsize/) {
      chomp $line;
      my @temp = split(/=/,$line);
      $testexceptionsize = $temp[1];
    }
    
    # find syslog servers in testsection
    if ($line =~ m/^server=\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/) { #expecting logost with IPs, not as hostname -> known limitation!
      chomp $line;
      my @temp = split (/=/,$line);
      $testsyslogservers[$testsyslogservercount]= $temp[1];
      $testsyslogservercount++
      }
    if ($testsyslogservercount > 0) {$checksylogservers = 1;}
    
    # find host statement in testsection
    if ($line =~ m/^host/) {
      chomp $line;
      my @temp = split (/=/,$line);
      $testhostservers[$testhostcount] = $temp[1];
      $testhostcount++;
    }
    if ($testhostcount > 0) {$checkhost = 1;}
    
    # find syslogbuffersize line testsection;
    if ($line =~ m/^buffersize/) {
      chomp $line;
      my @temp = split (/=/,$line);
      $testsyslogbuffersize = $temp[1];
      $checkbuffer = 1;
      
    }
    
    # find syslog buffer logging level in testsection
    if ($line =~ m/^bufferlevel/) {
      chomp $line;
      my @temp = split(/=/,$line);
      $testbufferlevel = $temp[1];
    }
    
    # find trap level in testsection
    if ($line =~ m/^traplevel/) {
      chomp $line;
      my @temp = split(/=/,$line);
      $testtraplevel = $temp[1];
      $checktrap = 1;
    }
    
    # find console logging level in testsection
    if ($line =~ m/^consolelevel/) {
      chomp $line;
      my @temp = split(/=/,$line);
      $testconsolelevel = $temp[1];
      $checkconsole = 1;
    }
    
    # find source interface in testsection
    if ($line =~ m/^source/) {
      chomp $line;
      my @temp = split(/=/,$line);
      $testsourceif = $temp[1];
      $checksource = 1;
    }
    
    # find facility in testsection
    if ($line =~ m/^facility/) {
      chomp $line;
      my @temp = split(/=/,$line);
      $testdefinedfacility = $temp[1];
      $checkfacility = 1;
    }
    
    # find monitor parameters in testsection
    if ($line =~ m/^monitor/) {
      chomp $line;
      my @temp = split(/=/,$line);
      $checkmonitor = 1;
      $testmonitorlevel = $temp[1];
    }
    
    # find if "logging count" is enabled in testsection
    if ($line =~ m/^count=/) {
      chomp $line;
      my @temp = split(/=/,$line);
      if ($temp[1] eq "enabled") {
        $checklinecount = 1;
        $testlinecount = 1;
      }
    }
    

  }
  
    
  # end of testsection analysis
  
  
  
  
  # test the config against the analyzed testsection
  
  foreach my $line (@$config) {
    
    # find syslog servers if test is defined
    if ($checksylogservers==1) {
      #foreach my $loghost (@testsyslogservers) {
        if ($line =~ m/^logging \d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}\n/) {
          chomp $line;
          $configsyslogservers[$configsyslogservercount]=$line;
          $configsyslogservercount++;
        }
      #}
    }
    
    # find if logging line count is enabled
    if ($checkbuffer == 1) {
      if ($line =~ m/logging count/) {
          chomp $line;
          my @temp = split(/ /,$line);
          $configlinecount = $temp[2];
      }
    }
    
    # find buffered logging level
    if ($checkbuffer == 1) {
      if ($line =~ m/logging buffered/) {
          chomp $line;
          my @temp = split(/ /,$line);
          $configbuffersize = $temp[2];
          $configbufferlevel = $temp[3];
          
      }
    }
    
    # find trap logging level
    if ($checktrap == 1) {
      if ($line =~ m/logging traps/) {
        chomp $line;
        my @temp = split(/ /,$line);
        $configtraplevel = $temp[2];
      }
    }
    
    # find console logging level
    if ($checkconsole == 1) {
      if ($line =~ m/logging console/) {
        chomp $line;
        my @temp = split(/ /,$line);
        $configconsolelevel = $temp[2];
      }
    }
    
    # if rate-limiting is enabled...
    if ($checkratelimit == 1) {
      if ($testratelimittype eq "excepted") {
        if ($line =~ m/^logging rate-limit \d{1,5} except/) {
          chomp $line;
          my @temp = split(/ /,$line);
          $configratelimittype = "excepted";
          $configratelimitmps = $temp[2];
          $configratelimittype = $temp[4];
        }
      }
      elsif ($testratelimittype eq "without") {
        if ($line =~ m/^logging rate-limit \d{1,5}/) {
          chomp $line;
          my @temp = split(/ /,$line);
          $configratelimittype = "without";
          $configratelimitmps = $temp[2];
        }
      }
      elsif ($testratelimittype eq "console") {
        if ($line =~ m/^logging rate-limit console \d{1,5}/) {
          chomp $line;
          my @temp = split(/ /,$line);
          $configratelimittype = "console";
          $configratelimitmps = $temp[3];
        }
          
      }
      elsif ($testratelimittype eq "all") {
        if ($line =~ m/^logging rate-limit all \d{1,5}/) {
          chomp $line;
          my @temp = split(/ /,$line);
          $configratelimittype = "all";
          $configratelimitmps = $temp[3];
        
        }
      }
      elsif ($testratelimittype eq "console-all") {
        if ($line =~ m/^logging rate-limit console all \d{1,5}/) {
          chomp $line;
          my @temp = split(/ /,$line);
          $configratelimittype = "console-all";
          $configratelimitmps = $temp[4];
        }
      }
    }
    
    # if origin-id is set
    if ($checkorigin == 1) {
      if ($testorigintype eq "string") {
        if ($line =~ m/^logging origin-id string/) {
          chomp $line;
          my @temp = split (/ /,$line);
          $configoriginstring = $temp[3];
          $configorigintype = $temp[2];
        }
      
      }
      
      elsif ($testorigintype eq ("ip" || "hostname")) {
        if ($line =~ m/^logging origin-id/) {
          chomp $line;
          my @temp = split (/ /,$line);
          $configorigintype = $temp[2];
        }
      }
    }
    
    # if history is defined...
    if ($checkhistory == 1) {
      if ($line =~ m/^logging history size/) {
        chomp $line;
        my @temp = split (/ /,$line);
        $confighistorysize = $temp[3];
      }
      elsif ($line =~ m/^logging history/) {
        chomp $line;
        my @temp = split (/ /,$line);
        $confighistorylevel = $temp[2];
      }
    }
    
    # if exception is set
    if ($checkexception == 1) {
      if ($line =~ m/^logging exception/) {
        chomp $line;
        my @temp = split(/ /,$line);
        $configexceptionsize = $temp[2];
        $configexception = 1;
      }
    }
    
    # if enhacned host statements exist
    if ($checkhost == 1) {
      foreach my $loghost (@testhostservers) {
        if ($line =~ m/^logging host/) {
          chomp $line;
          $line = substr($line,8);
          $confighost[$confighostcount]=$line;
          $confighostcount++;
        }
      }
    }
    
    # if source-interface is defined
    if ($checksource == 1) {
      if ($line =~ m/^logging source-interface/) {
        chomp $line;
        my @temp = split(/ /,$line);
        $configsourceif = $temp[2];
      }
    }
    
    # if facility is set
    if ($checkfacility == 1) {
      if ($line =~ m/^logging facility/) {
        chomp $line;
        my @temp = split(/ /,$line);
        $configdefinedfacility = $temp[2];
      }
    }
    
    # if monitor logging is defined
    if ($checkmonitor == 1) {
      if ($line =~ m/^logging monitor/) {
        chomp $line;
        my @temp = split(/ /,$line);
        $configmonitorlevel = $temp[2];
      }
    }
    
    # check if logging is disabled
    if ($line =~ m/^no logging on/) {$configlogenabled=0;}
    
  }
  
  # build the immensly complex return "hash of hashes"
 
  my %result = (
    'buffersize'          =>    {'enabled' =>  $checkbuffer,         'testspec' => $testsyslogbuffersize,    'actual' => $configbuffersize},
    'bufferlevel'         =>    {'enabled' =>  $checkbuffer,         'testspec' => $testbufferlevel,         'actual' => $configbufferlevel},
    'traplevel'           =>    {'enabled' =>  $checktrap,           'testspec' => $testtraplevel,           'actual' => $configtraplevel},
    'consolelevel'        =>    {'enabled' =>  $checkconsole,        'testspec' => $testconsolelevel,        'actual' => $configconsolelevel},
    'sourceif'            =>    {'enabled' =>  $checksource,         'testspec' => $testsourceif,            'actual' => $configsourceif},
    'facility'            =>    {'enabled' =>  $checkfacility,       'testspec' => $testdefinedfacility,     'actual' => $configdefinedfacility},
    'monitorlevel'        =>    {'enabled' =>  $checkmonitor,        'testspec' => $testmonitorlevel,        'actual' => $configmonitorlevel},
    'historysize'         =>    {'enabled' =>  $checkhistory,        'testspec' => $testhistorysize,         'actual' => $confighistorysize},
    'historylevel'        =>    {'enabled' =>  $checkhistory,        'testspec' => $testhistorylevel,        'actual' => $confighistorylevel},
    'origintype'          =>    {'enabled' =>  $checkorigin,         'testspec' => $testorigintype,          'actual' => $configorigintype},
    'originstring'        =>    {'enabled' =>  $checkorigin,         'testspec' => $testoriginstring,        'actual' => $configoriginstring},
    'ratelimittype'       =>    {'enabled' =>  $checkratelimit,      'testspec' => $testratelimittype,       'actual' => $configratelimittype},
    'ratelimitmps'        =>    {'enabled' =>  $checkratelimit,      'testspec' => $testratelimitmps,        'actual' => $configratelimitmps},
    'ratelimitexception'  =>    {'enabled' =>  $checkratelimit,      'testspec' => $testratelimitexcept,     'actual' => $configratelimitexcept},
    'loggingenable'       =>    {'enabled' =>  $configlogenabled},
    'linecount'           =>    {'enabled' =>  $checklinecount,      'testspec' => $testlinecount,           'actual' => $configlinecount},
    'syslogservers'       =>    {'enabled' =>  $checksylogservers,   'testspec' => [@testsyslogservers],       'actual' => [@configsyslogservers],  'testcount' => $testsyslogservercount,  'actualcount' => $configsyslogservercount},
    'hoststatements'      =>    {'enabled' =>  $checkhost,           'testspec' => [@testhostservers],         'actual' => [@confighost],           'testcount' => $testhostcount,          'actualcount' => $confighostcount},
   );
  
  
  return (%result);
}



sub testL2IF(\@;\@;$) { # @switchconfig; @l2if-tests; $verbose=[1|0], returns hash with per if-dtp-status
  
  my ($config, $testsection, $verbose) = ($_[1],$_[2],$_[3]);
  #print @$config;
  #print @$test;
  
  # default values for tests
  my $dtp="enabled";                          # default will assume that it is ok to enable dtp on an interfaced
  
  
  # find actual test-values from optionsfile and overwrite defaults if neccessary
  
  #print @$testsection;
  foreach my $line (@$testsection) {
    #print "$line \n";
    if ($line =~m/^dtp=disabled/)    {$dtp="disabled";}
    elsif ($line =~m/^dtp=enabled/) {$dtp="enabled";}
    else {;}  #failsafe -> default
  }
  
  
  # get ethernet interfaces out of config
  my $startline = 0;
  my $endline = @$config -1;
  my @inhalt;
  my $ethernetcounter=0;
  my @ethernetindex;
  my %dtpperif;
  
  for (my $i=$startline; $i<$endline;$i++) {
    #print @$config[$i];
    
    if ( (@$config[$i] =~ m/^interface (Fast|Gigabit|TenGigabit)Ethernet/) || (@$config[$i] =~ m/interface Port-channel/)){
      $ethernetcounter++;
      $ethernetindex[$ethernetcounter] = $i;
      #print "found Ethernetinterface or Port-Channel! \n";
      #print @$config[$i];
      
    }
  }
  
  if ($ethernetcounter > 0) {
    
  
    for (my $i=$ethernetindex[$ethernetcounter]; $i <$endline; $i++) {
      my $line = @$config[$i];
      if ($line =~ m/!/) {
       $ethernetindex[$ethernetcounter+1]=$i;
       last;
      }
    }
  
    #print "Total number of Ethernet interfaces is $ethernetcounter \n";
    #print "Linenumbers with Ethernetinterfaces are @ethernetindex \n";
    
    my $configlinecount; 
    my $dtpdisabled = "false";
    # false means dtp is not disabled
    # true means dtp is disabled
  
   if ($dtp eq "disabled") {   
    
      for (my $j=1; $j <= $ ethernetcounter; $j++) {
            $dtpdisabled = "false";
            $configlinecount = $ethernetindex[$j+1]-$ethernetindex[$j]-1;
            $dtpperif{"@$config[$ethernetindex[$j]]"} = "$dtpdisabled";
            #print "Number of config-lines: $configlinecount for interface @$config[$ethernetindex[$j]]";
            
            for (my $i=0; $i< $configlinecount; $i++) {
              if (@$config[$ethernetindex[$j]+$i] =~ m/switchport mode/) {
                # print "dtp line is present:" . $inhalt[$ethernetindex[$j]+$i];
                $dtpdisabled = "true";
                $dtpperif{"@$config[$ethernetindex[$j]]"} = "$dtpdisabled";
              }
              #print "DTP disabled for interface $inhalt[$ethernetindex[$j]]  $dtpdisabled\n";
            }
      }
      
      #while (my ($key, $value) = each(%dtpperif)){
      #   if ($value eq "false") {
      #   print $key . "dtp disabled: " . "$value \n";
      #   }
      #}
      
   } # end of if ($dtp=="disabled")
   else {
    #print "DTP will not be checked\n";
   }
    
    
    
  }
  
  return(%dtpperif);
}




sub testAAAGeneral(\@;\@;$) {   # @switchconfig; @aaa-general-test-section; $verbose=1|0
                              # testing general AAA parameters
  
  my ($config, $testsection, $verbose) = ($_[1],$_[2],$_[3]);
  
  my $checkusers=0;   # local users defined, do we test for them?
  my $checktacacs=0;  # tacacs server defined, do we test for them?
  my $checkradius=0;  # radius server defined, do we test for them?
  
  my %testusers = ();   # all defined users in testspec and their privilege level
  my $testusercount=0; # number of local users in the testspec
  my %configusers = (); # all defined users in config and their privilege level
  my $configusercount=0; # number of users in the config
  
  my @testtacacs;# = {}; # all defined tacacs servers in the testspec
  my @configtacacs;# = {}; # all defined tacacs servers in the config
  my $testtacacscount = 0; #number of tacacs servers in the testspec
  my $configtacacscount = 0; # number of tacacs servers in the config
  
  my @testradius;# = {}; # all defined radius servers in the testspec
  my @configradius;# = {}; # all defined radius servers in the config
  my $testradiuscount=0; # number of radius servers in the testspec
  my $configradiuscount=0; # number of radius servers in the config
  
  #analyzing the testsection
  foreach my $line (@$testsection) {
    
    #find all user-statements...
    if ($line =~ m/^user=/) {
      chomp $line;
      my @temp = split(/=/,$line);
      my ($name,$level) = split(/->/,$temp[1]);
      if ($level) {
        $testusers{$name} = $level;
      }
      else {
        $testusers{$name} = 15; # if no level is given in testspec, than level 15 is assumed (default IOS behaviour)
      }
      $testusercount++;
    }
    
    
    # find all tacacs-server statements
    if ($line =~ m/^tacacsserver=/) {
      $checktacacs=1;
      chomp $line;
      my @temp = split(/=/,$line);
      $testtacacs[$testtacacscount]=$temp[1];
      $testtacacscount++;
    }
    
    
    # find all radius-server statements
    if ($line =~ m/^radiusserver=/) {
      $checkradius=1;
      chomp $line;
      my @temp = split(/=/,$line);
      $testradius[$testradiuscount]=$temp[1];
      $testradiuscount++;
    }
    
    
  }
  
  
  # analyzing config
  foreach my $line (@$config) {
    
    # looking for local users and privileges...
    if ($line =~ m/^username/) { #found a user statement
      # there are two different ways of having a username statemen
      # username backup privilege 15 password 7 encpassword
      # username OPS password 7 encpassword
      $configusercount++;
      chomp $line;
      my @temp = split(/ /,$line);
      my $name = $temp[1];
      my $level = "undefined";
      if ($temp[2] eq "privilege") {
        $level = $temp[3];
      }
      elsif ($temp[2] eq "password") {
        $level = 15; #default
      }
      $configusers{$name} = $level;
    }
    
  
    # looking for tacacs-servers
    if ($line =~ m/^tacacs-server host/) {
      chomp $line;
      my @temp = split(/ /,$line);
      $configtacacs[$configtacacscount]=$temp[2];
      $configtacacscount++;
    }
    
    
    # looking for radius-servers
    if ($line =~ m/^radius-server host/) {
      chomp $line;
      my @temp = split(/ /,$line);
      $configradius[$configradiuscount]=$temp[2];
      $configradiuscount++;
    }
     
  }
  if ($configradiuscount > 0) {$checkradius=1;}
  if ($configusercount > 0) {$checkusers=1;}
  if ($configtacacscount > 0) {$checktacacs=1;}
  if ($testusercount > 0) {$checkusers=1;}
  if ($testtacacscount > 0) {$checktacacs = 1};
  if ($testradiuscount > 0) {$checkradius = 1;}
  
  
  my %returnhash = (
                    'checkradius' => $checkradius,
                    'checkusers' => $checkusers,
                    'checktacacs' => $checktacacs,
                    'testspec' => {%testusers},
                    'actual' => {%configusers},
                    'testradius' => [@testradius],
                    'testtacacs' => [@testtacacs],
                    'configradius' => [@configradius],
                    'configtacacs' => [@configtacacs]
                   );
  
  return %returnhash;
}

sub testAAAAuthentication(\@;\@;$) {
  my ($config, $testsection, $verbose) = ($_[1],$_[2],$_[3]);
  #print "******** In AAA Authentication testsection\n";
  return my %returnhash;
  
}



sub testServices(@;@;$) { # @switchconfig; @dns-test-config; $verbose=[1|0]
  
}






sub getCompleteFile($;$) { #$filename, $verbose, returns @contents_of_file
  
  my $filename = $_[1];  #handle arguments
  my $verbose  = $_[2];
    
  
  my @tempcontents;
  
  #print  $filename ."\n";
  #print  $verbose ."\n";
  
  open(my $FH,$filename) or die "cant find $filename";
  while (<$FH>) {
            @tempcontents = <$FH>;
  close $FH;
  return(@tempcontents);
  
  }
}




sub getHostname(@) { # return $hostname from config @
    my @content = @_;
    #print @content;
    my $linecount = scalar(@content);
    my $hostname="no_hostname_defined";
    if (@content) {
      for (my $i=0; $i < $linecount; $i++) {
        my $line = $content[$i];
        if ($line =~ m/^hostname/) {
          chomp $line;
          my @temp = split (/ /,$line);
          $hostname = $temp[1]
           
        }
      }
    }
    return($hostname);
}

1;