#!/usr/bin/perl -w

# sub prototypes
sub array_comp(\@;\@);
sub hash_comp(\%;\%);

# Version 0.1.2a, 15th Aug 2005


#License: This script & the Perl-Module are published under the GPL:

# This Software is copyright by Dror-John Roecher, 2005
# The author can be reached via mail: droecher@ernw.de
# There is no warranty that the software works, produces something useful,
# or wont break your system.
#
# This software is protected by the GNU General Public License
#
#
#		    GNU GENERAL PUBLIC LICENSE
#		       Version 2, June 1991
#
# Copyright (C) 1989, 1991 Free Software Foundation, Inc.
#                       51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
# Everyone is permitted to copy and distribute verbatim copies
# of this license document, but changing it is not allowed.
#
#			    Preamble
#
#  The licenses for most software are designed to take away your
#freedom to share and change it.  By contrast, the GNU General Public
#License is intended to guarantee your freedom to share and change free
#software--to make sure the software is free for all its users.  This
#General Public License applies to most of the Free Software
#Foundation's software and to any other program whose authors commit to
#using it.  (Some other Free Software Foundation software is covered by
#the GNU Library General Public License instead.)  You can apply it to
#your programs, too.
#
#  When we speak of free software, we are referring to freedom, not
#price.  Our General Public Licenses are designed to make sure that you
#have the freedom to distribute copies of free software (and charge for
#this service if you wish), that you receive source code or can get it
#if you want it, that you can change the software or use pieces of it
#in new free programs; and that you know you can do these things.
#
#  To protect your rights, we need to make restrictions that forbid
#anyone to deny you these rights or to ask you to surrender the rights.
#These restrictions translate to certain responsibilities for you if you
#distribute copies of the software, or if you modify it.
#
#  For example, if you distribute copies of such a program, whether
#gratis or for a fee, you must give the recipients all the rights that
#you have.  You must make sure that they, too, receive or can get the
#source code.  And you must show them these terms so they know their
#rights.
#
#  We protect your rights with two steps: (1) copyright the software, and
#(2) offer you this license which gives you legal permission to copy,
#distribute and/or modify the software.
#
#  Also, for each author's protection and ours, we want to make certain
#that everyone understands that there is no warranty for this free
#software.  If the software is modified by someone else and passed on, we
#want its recipients to know that what they have is not the original, so
#that any problems introduced by others will not reflect on the original
#authors' reputations.
#
#  Finally, any free program is threatened constantly by software
#patents.  We wish to avoid the danger that redistributors of a free
#program will individually obtain patent licenses, in effect making the
#program proprietary.  To prevent this, we have made it clear that any
#patent must be licensed for everyone's free use or not licensed at all.
#
#  The precise terms and conditions for copying, distribution and
#modification follow.
#
#		    GNU GENERAL PUBLIC LICENSE
#   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
#
#  0. This License applies to any program or other work which contains
#a notice placed by the copyright holder saying it may be distributed
#under the terms of this General Public License.  The "Program", below,
#refers to any such program or work, and a "work based on the Program"
#means either the Program or any derivative work under copyright law:
#that is to say, a work containing the Program or a portion of it,
#either verbatim or with modifications and/or translated into another
#language.  (Hereinafter, translation is included without limitation in
#the term "modification".)  Each licensee is addressed as "you".
#
#Activities other than copying, distribution and modification are not
#covered by this License; they are outside its scope.  The act of
#running the Program is not restricted, and the output from the Program
#is covered only if its contents constitute a work based on the
#Program (independent of having been made by running the Program).
#Whether that is true depends on what the Program does.
#
#  1. You may copy and distribute verbatim copies of the Program's
#source code as you receive it, in any medium, provided that you
#conspicuously and appropriately publish on each copy an appropriate
#copyright notice and disclaimer of warranty; keep intact all the
#notices that refer to this License and to the absence of any warranty;
#and give any other recipients of the Program a copy of this License
#along with the Program.
#
#You may charge a fee for the physical act of transferring a copy, and
#you may at your option offer warranty protection in exchange for a fee.
#
#  2. You may modify your copy or copies of the Program or any portion
#of it, thus forming a work based on the Program, and copy and
#distribute such modifications or work under the terms of Section 1
#above, provided that you also meet all of these conditions:
#
#    a) You must cause the modified files to carry prominent notices
#    stating that you changed the files and the date of any change.
#
#    b) You must cause any work that you distribute or publish, that in
#    whole or in part contains or is derived from the Program or any
#    part thereof, to be licensed as a whole at no charge to all third
#    parties under the terms of this License.
#
#    c) If the modified program normally reads commands interactively
#    when run, you must cause it, when started running for such
#    interactive use in the most ordinary way, to print or display an
#    announcement including an appropriate copyright notice and a
#    notice that there is no warranty (or else, saying that you provide
#    a warranty) and that users may redistribute the program under
#    these conditions, and telling the user how to view a copy of this
#    License.  (Exception: if the Program itself is interactive but
#    does not normally print such an announcement, your work based on
#    the Program is not required to print an announcement.)
#
#These requirements apply to the modified work as a whole.  If
#identifiable sections of that work are not derived from the Program,
#and can be reasonably considered independent and separate works in
#themselves, then this License, and its terms, do not apply to those
#sections when you distribute them as separate works.  But when you
#distribute the same sections as part of a whole which is a work based
#on the Program, the distribution of the whole must be on the terms of
#this License, whose permissions for other licensees extend to the
#entire whole, and thus to each and every part regardless of who wrote it.
#
#Thus, it is not the intent of this section to claim rights or contest
#your rights to work written entirely by you; rather, the intent is to
#exercise the right to control the distribution of derivative or
#collective works based on the Program.
#
#In addition, mere aggregation of another work not based on the Program
#with the Program (or with a work based on the Program) on a volume of
#a storage or distribution medium does not bring the other work under
#the scope of this License.
#
#  3. You may copy and distribute the Program (or a work based on it,
#under Section 2) in object code or executable form under the terms of
#Sections 1 and 2 above provided that you also do one of the following:
#
#    a) Accompany it with the complete corresponding machine-readable
#    source code, which must be distributed under the terms of Sections
#    1 and 2 above on a medium customarily used for software interchange; or,
#
#    b) Accompany it with a written offer, valid for at least three
#    years, to give any third party, for a charge no more than your
#    cost of physically performing source distribution, a complete
#    machine-readable copy of the corresponding source code, to be
#    distributed under the terms of Sections 1 and 2 above on a medium
#    customarily used for software interchange; or,
#
#    c) Accompany it with the information you received as to the offer
#    to distribute corresponding source code.  (This alternative is
#    allowed only for noncommercial distribution and only if you
#    received the program in object code or executable form with such
#    an offer, in accord with Subsection b above.)
#
#The source code for a work means the preferred form of the work for
#making modifications to it.  For an executable work, complete source
#code means all the source code for all modules it contains, plus any
#associated interface definition files, plus the scripts used to
#control compilation and installation of the executable.  However, as a
#special exception, the source code distributed need not include
#anything that is normally distributed (in either source or binary
#form) with the major components (compiler, kernel, and so on) of the
#operating system on which the executable runs, unless that component
#itself accompanies the executable.
#
#If distribution of executable or object code is made by offering
#access to copy from a designated place, then offering equivalent
#access to copy the source code from the same place counts as
#distribution of the source code, even though third parties are not
#compelled to copy the source along with the object code.
#
#  4. You may not copy, modify, sublicense, or distribute the Program
#except as expressly provided under this License.  Any attempt
#otherwise to copy, modify, sublicense or distribute the Program is
#void, and will automatically terminate your rights under this License.
#However, parties who have received copies, or rights, from you under
#this License will not have their licenses terminated so long as such
#parties remain in full compliance.
#
#  5. You are not required to accept this License, since you have not
#signed it.  However, nothing else grants you permission to modify or
#distribute the Program or its derivative works.  These actions are
#prohibited by law if you do not accept this License.  Therefore, by
#modifying or distributing the Program (or any work based on the
#Program), you indicate your acceptance of this License to do so, and
#all its terms and conditions for copying, distributing or modifying
#the Program or works based on it.
#
#  6. Each time you redistribute the Program (or any work based on the
#Program), the recipient automatically receives a license from the
#original licensor to copy, distribute or modify the Program subject to
#these terms and conditions.  You may not impose any further
#restrictions on the recipients' exercise of the rights granted herein.
#You are not responsible for enforcing compliance by third parties to
#this License.
#
#  7. If, as a consequence of a court judgment or allegation of patent
#infringement or for any other reason (not limited to patent issues),
#conditions are imposed on you (whether by court order, agreement or
#otherwise) that contradict the conditions of this License, they do not
#excuse you from the conditions of this License.  If you cannot
#distribute so as to satisfy simultaneously your obligations under this
#License and any other pertinent obligations, then as a consequence you
#may not distribute the Program at all.  For example, if a patent
#license would not permit royalty-free redistribution of the Program by
#all those who receive copies directly or indirectly through you, then
#the only way you could satisfy both it and this License would be to
#refrain entirely from distribution of the Program.
#
#If any portion of this section is held invalid or unenforceable under
#any particular circumstance, the balance of the section is intended to
#apply and the section as a whole is intended to apply in other
#circumstances.
#
#It is not the purpose of this section to induce you to infringe any
#patents or other property right claims or to contest validity of any
#such claims; this section has the sole purpose of protecting the
#integrity of the free software distribution system, which is
#implemented by public license practices.  Many people have made
#generous contributions to the wide range of software distributed
#through that system in reliance on consistent application of that
#system; it is up to the author/donor to decide if he or she is willing
#to distribute software through any other system and a licensee cannot
#impose that choice.
#
#This section is intended to make thoroughly clear what is believed to
#be a consequence of the rest of this License.
#
#  8. If the distribution and/or use of the Program is restricted in
#certain countries either by patents or by copyrighted interfaces, the
#original copyright holder who places the Program under this License
#may add an explicit geographical distribution limitation excluding
#those countries, so that distribution is permitted only in or among
#countries not thus excluded.  In such case, this License incorporates
#the limitation as if written in the body of this License.
#
#  9. The Free Software Foundation may publish revised and/or new versions
#of the General Public License from time to time.  Such new versions will
#be similar in spirit to the present version, but may differ in detail to
#address new problems or concerns.
#
#Each version is given a distinguishing version number.  If the Program
#specifies a version number of this License which applies to it and "any
#later version", you have the option of following the terms and conditions
#either of that version or of any later version published by the Free
#Software Foundation.  If the Program does not specify a version number of
#this License, you may choose any version ever published by the Free Software
#Foundation.
#
#  10. If you wish to incorporate parts of the Program into other free
#programs whose distribution conditions are different, write to the author
#to ask for permission.  For software which is copyrighted by the Free
#Software Foundation, write to the Free Software Foundation; we sometimes
#make exceptions for this.  Our decision will be guided by the two goals
#of preserving the free status of all derivatives of our free software and
#of promoting the sharing and reuse of software generally.
#
#			    NO WARRANTY
#
#  11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
#FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
#OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
#PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
#OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
#TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
#PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
#REPAIR OR CORRECTION.
#
#  12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
#WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
#REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
#INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
#OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
#TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
#YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
#PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
#POSSIBILITY OF SUCH DAMAGES.
#
#		     END OF TERMS AND CONDITIONS
#
#	    How to Apply These Terms to Your New Programs
#
#  If you develop a new program, and you want it to be of the greatest
#possible use to the public, the best way to achieve this is to make it
#free software which everyone can redistribute and change under these terms.
#
#  To do so, attach the following notices to the program.  It is safest
#to attach them to the start of each source file to most effectively
#convey the exclusion of warranty; and each file should have at least
#the "copyright" line and a pointer to where the full notice is found.
#
#    <one line to give the program's name and a brief idea of what it does.>
#    Copyright (C) <year>  <name of author>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
#
#Also add information on how to contact you by electronic and paper mail.
#
#If the program is interactive, make it output a short notice like this
#when it starts in an interactive mode:
#
#    Gnomovision version 69, Copyright (C) year name of author
#    Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
#    This is free software, and you are welcome to redistribute it
#    under certain conditions; type `show c' for details.
#
#The hypothetical commands `show w' and `show c' should show the appropriate
#parts of the General Public License.  Of course, the commands you use may
#be called something other than `show w' and `show c'; they could even be
#mouse-clicks or menu items--whatever suits your program.
#
#You should also get your employer (if you work as a programmer) or your
#school, if any, to sign a "copyright disclaimer" for the program, if
#necessary.  Here is a sample; alter the names:
#
#  Yoyodyne, Inc., hereby disclaims all copyright interest in the program
#  `Gnomovision' (which makes passes at compilers) written by James Hacker.
#
#  <signature of Ty Coon>, 1 April 1989
#  Ty Coon, President of Vice
#
#This General Public License does not permit incorporating your program into
#proprietary programs.  If your program is a subroutine library, you may
#consider it more useful to permit linking proprietary applications with the
#library.  If this is what you want to do, use the GNU Library General
#Public License instead of this License.




use strict;
use Dror::ConfigAnalyzer;
use GetOpt::Long;
#use HTTP::Date;

#sub PrintResultsByHost(\%;\%;\%;\%;\%;$);
#sub PrintResultsByHost(\%;$);



my $basedir='';              #directory where switchconfigs and test-configuration file are stored
my $filetype='';             #fileextension of switch-config, defaults to "txt"
my $bscaconf='';             #the file where the tests are defined, with a default values
my $verbose=0;               #be verbose? default is "no"
my $resultbyhost=0;          #sort results by host 
my $resultbytest=1;          #sort results by test (default)
my @allfiles;                #name of all config files in basedir

Getopt::Long::GetOptions('base=s' => \$basedir,             #get command-line arguments
                         'type=s' => \$filetype,
                         'conf=s' => \$bscaconf,
                         'verbose'=>\$verbose,
                         'resultbyhost' => \$resultbyhost,
                         'resultbytest' => \$resultbytest
                         );




### testsection starting here -> should be removed later
    #my $config = ConfigAnalyzer->new();
    #my %inhalt = $config ->ConfigAnalyzer::ReadOption($basedir,$bscaconf,$verbose);
    #
    #my $file = $basedir ."\\". $bscaconf;
    #my $switchfile='c:\configs\NHSSWHMSD3.txt';
    #
    #my @testsection = $config ->ConfigAnalyzer::getFileLines($inhalt{"l2if_start"},$inhalt{"l2if_end"},$file,$verbose);
    ##print "\n Testsection \n @testsection \n";
    #
    #my @configfile = $config ->ConfigAnalyzer::getCompleteFile($switchfile,$verbose);
    ##print "\n Config is \n @configfile \n";
    #
    #
    ##my $hostname = $config ->ConfigAnalyzer::getHostname(@configfile);
    ##print "returned hostname is $hostname\n";
    #
    #$config -> ConfigAnalyzer::testL2IF(\@configfile,\@testsection,$verbose);
### testsection ends here -> should be removed later



# $audit is new audit-object
my $audit = ConfigAnalyzer->new();                                          


# get the testspec from the optionsfile
my %testspec = $audit -> ConfigAnalyzer::ReadOption($basedir,$bscaconf,$verbose);
my @testsection_l2if        = $audit ->ConfigAnalyzer::getFileLines($testspec{"l2if_start"},$testspec{"l2if_end"},$basedir."\\".$bscaconf,$verbose);
my @testsection_dns         = $audit ->ConfigAnalyzer::getFileLines($testspec{"dns_start"},$testspec{"dns_end"},$basedir."\\".$bscaconf,$verbose);
my @testsection_snmp        = $audit ->ConfigAnalyzer::getFileLines($testspec{"snmp_start"},$testspec{"snmp_end"},$basedir."\\".$bscaconf,$verbose);
my @testsection_syslog      = $audit ->ConfigAnalyzer::getFileLines($testspec{"syslog_start"},$testspec{"syslog_end"},$basedir."\\".$bscaconf,$verbose);
my @testsection_services    = $audit ->ConfigAnalyzer::getFileLines($testspec{"services_start"},$testspec{"services_end"},$basedir."\\".$bscaconf,$verbose);
my @testsection_aaa_authentication    = $audit ->ConfigAnalyzer::getFileLines($testspec{"aaa_authentication_start"},$testspec{"aaa_authentication_end"},$basedir."\\".$bscaconf,$verbose);
my @testsection_aaa_authorization    = $audit ->ConfigAnalyzer::getFileLines($testspec{"aaa_authorization_start"},$testspec{"aaa_authorization_end"},$basedir."\\".$bscaconf,$verbose);
my @testsection_aaa_accounting    = $audit ->ConfigAnalyzer::getFileLines($testspec{"aaa_accounting_start"},$testspec{"aaa_accounting_end"},$basedir."\\".$bscaconf,$verbose);
my @testsection_aaa_general    = $audit ->ConfigAnalyzer::getFileLines($testspec{"aaa_general_start"},$testspec{"aaa_general_end"},$basedir."\\".$bscaconf,$verbose);







print "\n";
print "***************************************************************\n";
print "*                                                             *\n";
print "*                           Starting Audit                    *\n";
print "*                    this may take a few minutes              *\n";
print "*                                                             *\n";
print "***************************************************************\n";




# get all config-filenames and put in an array
opendir(DIR, "$basedir");
my @files = grep(/\.$filetype$/,readdir(DIR));
closedir(DIR);



#### looping through tests by hosts
if ($resultbyhost==1) {
    foreach my $file (@files) {
        print "\n\n_____________________________\nOpened: $file \n";
        my @switchconfig = $audit ->ConfigAnalyzer::getCompleteFile($basedir."\\".$file,$verbose);
        my $hostname = $audit ->ConfigAnalyzer::getHostname(@switchconfig);
        print "Hostname is $hostname\n";
        print "starting layer2-interface audit...";
        my %dtpperifresult = $audit -> ConfigAnalyzer::testL2IF(\@switchconfig,\@testsection_l2if,$verbose);
        my $numberl2if = keys(%dtpperifresult);
        print "done!\n";
        print "starting syslog audit...";
        my %syslogresult = $audit -> ConfigAnalyzer::testSyslog(\@switchconfig,\@testsection_syslog,$verbose);
        print "done!\n";
        print "starting AAA audit...";
        my %aaa_general_result = $audit -> ConfigAnalyzer::testAAAGeneral(\@switchconfig,\@testsection_aaa_general,$verbose);
        my %aaa_authenticaion_result = $audit -> ConfigAnalyzer::testAAAAuthentication(\@switchconfig,\@testsection_aaa_authentication,$verbose);
        print "done!\n";
        #print "___debugging info: number of keys in dtphash is:" . keys(%dtpperif) ."\n";
        
        #while (my ($key, $value) = each(%dtpperif)){
        #    print $key ."\t\t\t". $value ."\n";
        #}
        
        
        
        #############################################################
        #
        #                Result Printing below this point 
        #
        #############################################################
    
        # resultfilename creation (hostname_date.txt)
        my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime time;
        $year = $year+1900;
        $mon++;
        if ($mon < 10) {$mon = "0".$mon;}
        if ($mday < 10) {$mday = "0".$mday;}
        if ($hour < 10) {$hour = "0".$hour;}
        if ($min < 10) {$min = "0".$min;}
        if ($sec < 10) {$sec = "0".$sec;}
        my $writetime = "$year"."$mon"."$mday"."$hour"."$min"."$sec";
        my $outfilename = $hostname."_".$writetime.".html";
    
        my $backcolor = "#000000"; # color used for display in tables (green=passed; red = failed)
        my $passcolor = "#33ff66";
        my $failcolor = "#ff0000";
        my $checkcolor = "#F5FC01";
        
        
        print "ResultFile will be $basedir\\$outfilename\n";
        open(OUTFILE, ">$basedir\\$outfilename");
        
        print OUTFILE "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">\n";
        print OUTFILE "<html>\n";
        print OUTFILE "<head>\n";
        print OUTFILE "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=ISO-8859-1\">\n";
        print OUTFILE "<title> Results for $hostname </title>\n";
        print OUTFILE "</head>\n";
        print OUTFILE "<body>\n";
        print OUTFILE "<basefont face = \"Arial, Verdana, Times New Roman\" size = \"+2\">\n";
        
        print OUTFILE "<H2>Audit Result for $hostname</H2>\n";
        print OUTFILE "<p>\n";
        #print OUTFILE "<hr width=\"500\" align=\"left\">\n";
        
        # printing the overview-table
        print OUTFILE "<table border=\"1\">\n";
        print OUTFILE "<colgroup>\n";
        print OUTFILE "<col width=\"120\">\n";
        print OUTFILE "<col width=\"400\">\n";
        print OUTFILE "</colgroup>\n";
        print OUTFILE "<tr>\n";
        print OUTFILE "<td> Audit time: </td> <td>$year/$mon/$mday $hour:$min:$sec</td>\n";
        print OUTFILE "</tr><tr>\n";
        print OUTFILE "<td>Audit result in:</td><td> $basedir\\$outfilename</td>\n";
        print OUTFILE "</tr><tr>\n";
        print OUTFILE "<td>Audited file is:</td><td> $basedir\\$file</td>\n";
        print OUTFILE "</tr><tr>\n";
        print OUTFILE "<td>Testspec file is:</td><td> $basedir\\$bscaconf</td>\n";
        print OUTFILE "</tr>\n";
        print OUTFILE "</table>\n";
        print OUTFILE "<p>\n";
        
        #########################################################################
        #
        # printing the general Syslog results
        #
        #########################################################################
        
        print OUTFILE "<H3>Syslog Audit Results</H3><p>\n"; 
        print OUTFILE "<H4>1. General Syslog Settings Audit</H3><p>\n";
        print OUTFILE "<table border=\"1\">\n";
        print OUTFILE "<colgroup>\n";
        print OUTFILE "<col width=\"200\">\n";
        print OUTFILE "<col width=\"200\">\n";
        print OUTFILE "<col width=\"200\">\n";
        print OUTFILE "</colgroup>\n";
        print OUTFILE "<tr>\n";
        print OUTFILE "<th>Testname</th><th>Expected</th><th>Actual</th>\n";
        print OUTFILE "</tr>\n";
        
        # printing logging enabled status
        if ($syslogresult{'loggingenable'}->{'enabled'} eq "1") {
            print OUTFILE "<tr>\n";
            print OUTFILE "<td bgcolor=\"$passcolor\">Logging Status</td>\n";
            print OUTFILE "<td bgcolor=\"$passcolor\">&nbsp;</td>\n";
            print OUTFILE "<td bgcolor=\"$passcolor\">logging is enabled <br> via \" logging on \"</td>\n";
            print OUTFILE "</tr>\n";
        }
         elsif ($syslogresult{'loggingenable'}->{'enabled'} eq "0") {
            print OUTFILE "<tr>\n";
            print OUTFILE "<td bgcolor=\"$failcolor\">Logging Status</td>\n";
            print OUTFILE "<td bgcolor=\"$failcolor\">&nbsp;</td>\n";
            print OUTFILE "<td bgcolor=\"$failcolor\">logging is disabled <br> via \no logging on\</td>\n";
            print OUTFILE "</tr>\n";
        }
         
         # printing of linecount result
         if ($syslogresult{'linecount'}->{'enabled'} eq "1") {
            if ($syslogresult{'linecount'} -> {'testspec'} ne $syslogresult{'linecount'}-> {'actual'}) {
                $backcolor = $failcolor;
            }
            elsif ($syslogresult{'linecount'} -> {'testspec'} eq $syslogresult{'linecount'}-> {'actual'}) {
                $backcolor = $passcolor;
            }
            print OUTFILE "<tr>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">Linecount enabled?</td>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'linecount'}->{'testspec'} </td>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'linecount'}->{'actual'} </td>\n";
            print OUTFILE "</tr>\n";
        }

        # printing buffer-level & buffer-size results
        if ($syslogresult{'bufferlevel'}->{'enabled'} eq "1") {
            if ($syslogresult{'bufferlevel'} -> {'testspec'} ne $syslogresult{'bufferlevel'}-> {'actual'}) {
                $backcolor = $failcolor;
            }
            elsif ($syslogresult{'bufferlevel'} -> {'testspec'} eq $syslogresult{'bufferlevel'}-> {'actual'}) {
                $backcolor = $passcolor;
            }
            print OUTFILE "<tr>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">Local Buffer Logging Level</td>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'bufferlevel'}->{'testspec'} </td>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'bufferlevel'}->{'actual'} </td>\n";
            print OUTFILE "</tr>\n";
            if ($syslogresult{'buffersize'} -> {'testspec'} ne $syslogresult{'buffersize'}-> {'actual'}) {
                $backcolor = $failcolor;
            }
            elsif ($syslogresult{'buffersize'} -> {'testspec'} eq $syslogresult{'buffersize'}-> {'actual'}) {
                $backcolor = $passcolor;
            }
            print OUTFILE "<tr>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">Local Buffer Size</td>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'buffersize'}->{'testspec'} </td>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'buffersize'}->{'actual'} </td>\n";
            print OUTFILE "</tr>\n";
        }
        
        # printint trap-level result
        if ($syslogresult{'traplevel'}->{'enabled'} eq "1") {
            if ($syslogresult{'traplevel'} -> {'testspec'} ne $syslogresult{'traplevel'}-> {'actual'}) {
                $backcolor = $failcolor;
            }
            elsif ($syslogresult{'traplevel'} -> {'testspec'} eq $syslogresult{'traplevel'}-> {'actual'}) {
                $backcolor = $passcolor;
            }
            print OUTFILE "<tr>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">Traplevel / Sysloglevel</td>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'traplevel'}->{'testspec'} </td>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'traplevel'}->{'actual'} </td>\n";
            print OUTFILE "</tr>\n";
        }
        
        # printing console-level result
        if ($syslogresult{'consolelevel'}->{'enabled'} eq "1") {
            if ($syslogresult{'consolelevel'} -> {'testspec'} ne $syslogresult{'consolelevel'}-> {'actual'}) {
                $backcolor = $failcolor;
            }
            elsif ($syslogresult{'consolelevel'} -> {'testspec'} eq $syslogresult{'consolelevel'}-> {'actual'}) {
                $backcolor = $passcolor;
            }
            print OUTFILE "<tr>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">Consolelevel Logging</td>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'consolelevel'}->{'testspec'} </td>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'consolelevel'}->{'actual'} </td>\n";
            print OUTFILE "</tr>\n";
        }
        
        # print monitor-level results
        if ($syslogresult{'monitorlevel'}->{'enabled'} eq "1") {
            if ($syslogresult{'monitorlevel'} -> {'testspec'} ne $syslogresult{'monitorlevel'}-> {'actual'}) {
                $backcolor = $failcolor;
            }
            elsif ($syslogresult{'monitorlevel'} -> {'testspec'} eq $syslogresult{'monitorlevel'}-> {'actual'}) {
                $backcolor = $passcolor;
            }
            print OUTFILE "<tr>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">Monitorevel Logging</td>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'monitorlevel'}->{'testspec'} </td>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'monitorlevel'}->{'actual'} </td>\n";
            print OUTFILE "</tr>\n";
        }
        
        # print facility-level results
        if ($syslogresult{'facility'}->{'enabled'} eq "1") {
            if ($syslogresult{'facility'} -> {'testspec'} ne $syslogresult{'facility'}-> {'actual'}) {
                $backcolor = $failcolor;
            }
            elsif ($syslogresult{'facility'} -> {'testspec'} eq $syslogresult{'facility'}-> {'actual'}) {
                $backcolor = $passcolor;
            }
            print OUTFILE "<tr>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">Logging Facility</td>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'facility'}->{'testspec'} </td>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'facility'}->{'actual'} </td>\n";
            print OUTFILE "</tr>\n";
        }

        # print sourceinterface-level results
        if ($syslogresult{'sourceif'}->{'enabled'} eq "1") {
            if ($syslogresult{'sourceif'} -> {'testspec'} ne $syslogresult{'sourceif'}-> {'actual'}) {
                $backcolor = $failcolor;
            }
            elsif ($syslogresult{'sourceif'} -> {'testspec'} eq $syslogresult{'sourceif'}-> {'actual'}) {
                $backcolor = $passcolor;
            }
            print OUTFILE "<tr>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">Source Interface</td>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'sourceif'}->{'testspec'} </td>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'sourceif'}->{'actual'} </td>\n";
            print OUTFILE "</tr>\n";
        }

        # printing history level & size
        if ($syslogresult{'historylevel'}->{'enabled'} eq "1") {
            if ($syslogresult{'historylevel'} -> {'testspec'} ne $syslogresult{'historylevel'}-> {'actual'}) {
                $backcolor = $failcolor;
            }
            elsif ($syslogresult{'historylevel'} -> {'testspec'} eq $syslogresult{'historylevel'}-> {'actual'}) {
                $backcolor = $passcolor;
            }
            print OUTFILE "<tr>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">History Logging Level</td>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'historylevel'}->{'testspec'} </td>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'historylevel'}->{'actual'} </td>\n";
            print OUTFILE "</tr>\n";
            if ($syslogresult{'historysize'} -> {'testspec'} ne $syslogresult{'historysize'}-> {'actual'}) {
                $backcolor = $failcolor;
            }
            elsif ($syslogresult{'historysize'} -> {'testspec'} eq $syslogresult{'historysize'}-> {'actual'}) {
                $backcolor = $passcolor;
            }
            print OUTFILE "<tr>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">History Buffer Size</td>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'historysize'}->{'testspec'} </td>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'historysize'}->{'actual'} </td>\n";
            print OUTFILE "</tr>\n";
        }
        
        # printing origin information
        if ($syslogresult{'origintype'}->{'enabled'} eq "1") {
            if ($syslogresult{'origintype'} -> {'testspec'} ne $syslogresult{'origintype'}-> {'actual'}) {
                $backcolor = $failcolor;
            }
            elsif ($syslogresult{'origintype'} -> {'testspec'} eq $syslogresult{'origintype'}-> {'actual'}) {
                $backcolor = $passcolor;
            }
            print OUTFILE "<tr>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">Origin Type</td>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'origintype'}->{'testspec'} </td>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'origintype'}->{'actual'} </td>\n";
            print OUTFILE "</tr>\n";
            
            if ($syslogresult{'origintype'}->{'testspec'} eq "string") {
                print OUTFILE "<tr>\n";
                print OUTFILE "<td bgcolor=\"$backcolor\">Origin String</td>\n";
                print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'originstring'}->{'testspec'} </td>\n";
                print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'originstring'}->{'actual'} </td>\n";
                print OUTFILE "</tr>\n";
            }
        }
        
        # printing rate-limit information
        if ($syslogresult{'ratelimittype'}->{'enabled'} eq "1") {
            if ($syslogresult{'ratelimittype'} -> {'testspec'} ne $syslogresult{'ratelimittype'}-> {'actual'}) {
                $backcolor = $failcolor;
            }
            elsif ($syslogresult{'ratelimittype'} -> {'testspec'} eq $syslogresult{'ratelimittype'}-> {'actual'}) {
                $backcolor = $passcolor;
            }
            print OUTFILE "<tr>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">Ratelimit Type</td>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'ratelimittype'}->{'testspec'} </td>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'ratelimittype'}->{'actual'} </td>\n";
            print OUTFILE "</tr>\n";
            
            if ($syslogresult{'ratelimitmps'} -> {'testspec'} ne $syslogresult{'ratelimitmps'}-> {'actual'}) {
                $backcolor = $failcolor;
            }
            elsif ($syslogresult{'ratelimitmps'} -> {'testspec'} eq $syslogresult{'ratelimitmps'}-> {'actual'}) {
                $backcolor = $passcolor;
            }
            
            print OUTFILE "<tr>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">Ratelimit Messages <br> per second</td>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'ratelimitmps'}->{'testspec'} </td>\n";
            print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'ratelimitmps'}->{'actual'} </td>\n";
            print OUTFILE "</tr>\n";
            
            if ($syslogresult{'ratelimittype'}->{'testspec'} eq "excepted") {
                if ($syslogresult{'ratelimitexception'} -> {'testspec'} ne $syslogresult{'ratelimitexception'}-> {'actual'}) {
                    $backcolor = $failcolor;
                }
                elsif ($syslogresult{'ratelimitexception'} -> {'testspec'} eq $syslogresult{'ratelimitexception'}-> {'actual'}) {
                    $backcolor = $passcolor;
                }   
                print OUTFILE "<tr>\n";
                print OUTFILE "<td bgcolor=\"$backcolor\">Ratelimit Exception</td>\n";
                print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'ratelimitexception'}->{'testspec'} </td>\n";
                print OUTFILE "<td bgcolor=\"$backcolor\">$syslogresult{'ratelimitexception'}->{'actual'} </td>\n";
                print OUTFILE "</tr>\n";
            }
        }

        
        print OUTFILE "</table>\n";
        
        #########################################################################
        #
        # printing the Syslog Server results
        #
        #########################################################################
        
        if ($syslogresult{'syslogservers'}->{'enabled'} eq  "1") {
        
            my %seentestspec = ();
            my %seenconfig = ();
            my @testspeconly =();
            my @configonly = ();
            my %both = ();
            my @both = ();
            my @union = ();
            my %union = ();
            my $testcount = $syslogresult{'syslogservers'}->{'testcount'};
            my $confcount = $syslogresult{'syslogservers'}->{'actualcount'};
            my @testservers = ();
            my @confservers = ();
            my @isect = ();
            my %isect = ();
            
            
            #print "Number of Syslog  Syslog in Testspec is $testcount and in Config is $confcount\n";
            
            # populate @testservers
            for (my $i=0; $i < $testcount; $i++) {
                $testservers[$i] = $syslogresult{'syslogservers'}->{'testspec'}[$i];
            }
            
            # populate @confservers
            for (my $i=0; $i < $confcount; $i++) {
                my $line = $syslogresult{'syslogservers'}->{'actual'}[$i];
                $line = substr($line,8); #remove "logging " form "logging 1.2.3.4"
                $confservers[$i] = $line;
            }
            
            
            # print the table-header
            #
            print OUTFILE "<H4>2. Syslog Servers Audit Results</H3><p>\n"; 
        
            print OUTFILE "<table border=\"1\">\n";
            print OUTFILE "<colgroup>\n";
            print OUTFILE "<col width=\"200\">\n";
            print OUTFILE "<col width=\"200\">\n";
            print OUTFILE "</colgroup>\n";
            print OUTFILE "<tr>\n";
            print OUTFILE "<th>Expected</th><th>Actual</th>\n";
            print OUTFILE "</tr>\n";
            
            
            
            if ($testcount > 0 && $confcount > 0) { #only if both have entries: union, diff, etc. is needed
            
                # find all unique entries in testservers
                foreach my $item (@confservers) {
                    chomp $item;
                    $seentestspec{$item}=1;
                }
                foreach my $item (@testservers) {
                    chomp $item;
                    unless ($seentestspec{$item}) {
                        push(@testspeconly,$item);
                    }
                }
                
                # find all unique entries in configservres
                foreach my $item (@testservers) {
                    chomp $item;
                    $seenconfig{$item}=1;
                }
                foreach my $item (@confservers) {
                    chomp $item;
                    unless ($seenconfig{$item}) {
                        push(@configonly,$item);
                    }
                }
                
                # find shared entries in configservers & testservers
                
                foreach my $item (@confservers) {$both{$item}=1}
                foreach my $item (@testservers) {
                    if ($both{$item}) {$isect{$item}=1}
                    $both{$item}=1;
                }
                @both = keys %both;
                @isect = keys %isect;
                    
                
                # print table for each shared item
                #
                foreach my $item (@isect) {
                    print OUTFILE "<tr>\n";
                    print OUTFILE "<td bgcolor=\"$passcolor\">$item</td><td bgcolor=\"$passcolor\">$item</td>\n";
                    print OUTFILE "</tr>\n";
                }
                
                # print table for items in testspec only
                foreach my $item (@testspeconly) {
                    print OUTFILE "<tr>\n";
                    print OUTFILE "<td bgcolor=\"$failcolor\">$item</td><td bgcolor=\"$failcolor\">unmatched</td>\n";
                    print OUTFILE "</tr>\n";
                }
                # print table for items in config only
                foreach my $item (@configonly) {
                    print OUTFILE "<tr>\n";
                    print OUTFILE "<td bgcolor=\"$failcolor\">unmatched</td><td bgcolor=\"$failcolor\">$item</td>\n";
                    print OUTFILE "</tr>\n";
                }
            }
            
            elsif ($confcount == 0 && $testcount > 0) { #if only testservers has entries
                # print table for items in testspec only
                foreach my $item (@testservers) {
                    print OUTFILE "<tr>\n";
                    print OUTFILE "<td bgcolor=\"$failcolor\">$item</td><td bgcolor=\"$failcolor\">unmatched</td>\n";
                    print OUTFILE "</tr>\n";
                }
            }
            
            
            elsif ($testcount == 0 && $confcount >0 ) { #if only confservers
                # print table for items in testspec only
                foreach my $item (@confservers) {
                    print OUTFILE "<tr>\n";
                    print OUTFILE "<td bgcolor=\"$failcolor\">$item</td><td bgcolor=\"$failcolor\">unmatched</td>\n";
                    print OUTFILE "</tr>\n";
                }
                
            }
            
            
            print OUTFILE "</table>\n";
            print OUTFILE "<p>\n";
            
            
        }
        
        #########################################################################
        #
        # printing the syslog hoststatements results
        #
        #########################################################################
        
        if ($syslogresult{'hoststatements'}->{'enabled'} eq  "1") {
        
            my %seentestspec = ();
            my %seenconfig = ();
            my @testspeconly =();
            my @configonly = ();
            my %both = ();
            my @both = ();
            my @union = ();
            my %union = ();
            my $testcount = $syslogresult{'hoststatements'}->{'testcount'};
            my $confcount = $syslogresult{'hoststatements'}->{'actualcount'};
            my @testservers = ();
            my @confservers = ();
            my @isect = ();
            my %isect = ();
            
            
            #print "Number of Syslog  Syslog in Testspec is $testcount and in Config is $confcount\n";
            
            # populate @testservers
            for (my $i=0; $i < $testcount; $i++) {
                $testservers[$i] = "host ".$syslogresult{'hoststatements'}->{'testspec'}[$i];
                #print "DEBUGGIGNG____HOSTSTATEMENTS in TESTSTEPC\n";
                #print $testservers[$i]."\n";
            }
            
            # populate @confservers
            for (my $i=0; $i < $confcount; $i++) {
                my $line = $syslogresult{'hoststatements'}->{'actual'}[$i];
                #$line = substr($line,8); #remove "logging " form "logging 1.2.3.4"
                #print "DEBUGGGING______HOSTSTATEMENTS in CONFIG___\n";
                #print $line ."\n";
                $confservers[$i] = $line;
            }
            
            
            # print the table-header
            #
            print OUTFILE "<H4>3. Syslog Host-Statements Audit Results</H3><p>\n"; 
        
            print OUTFILE "<table border=\"1\">\n";
            print OUTFILE "<colgroup>\n";
            print OUTFILE "<col width=\"200\">\n";
            print OUTFILE "<col width=\"200\">\n";
            print OUTFILE "</colgroup>\n";
            print OUTFILE "<tr>\n";
            print OUTFILE "<th>Expected</th><th>Actual</th>\n";
            print OUTFILE "</tr>\n";
            
            
            
            if ($testcount > 0 && $confcount > 0) { #only if both have entries: union, diff, etc. is needed
            
                # find all unique entries in testservers
                foreach my $item (@confservers) {
                    #chomp $item;
                    $seentestspec{$item}=1;
                }
                foreach my $item (@testservers) {
                    #chomp $item;
                    unless ($seentestspec{$item}) {
                        push(@testspeconly,$item);
                    }
                }
                
                # find all unique entries in configservres
                foreach my $item (@testservers) {
                    #chomp $item;
                    $seenconfig{$item}=1;
                }
                foreach my $item (@confservers) {
                    #chomp $item;
                    unless ($seenconfig{$item}) {
                        push(@configonly,$item);
                    }
                }
                
                # find shared entries in configservers & testservers
                
                foreach my $item (@confservers) {$both{$item}=1}
                foreach my $item (@testservers) {
                    if ($both{$item}) {$isect{$item}=1}
                    $both{$item}=1;
                }
                @both = keys %both;
                @isect = keys %isect;
                    
                
                # print table for each shared item
                #
                foreach my $item (@isect) {
                    print OUTFILE "<tr>\n";
                    print OUTFILE "<td bgcolor=\"$passcolor\">$item</td><td bgcolor=\"$passcolor\">$item</td>\n";
                    print OUTFILE "</tr>\n";
                }
                
                # print table for items in testspec only
                foreach my $item (@testspeconly) {
                    print OUTFILE "<tr>\n";
                    print OUTFILE "<td bgcolor=\"$failcolor\">$item</td><td bgcolor=\"$failcolor\">unmatched</td>\n";
                    print OUTFILE "</tr>\n";
                }
                # print table for items in config only
                foreach my $item (@configonly) {
                    print OUTFILE "<tr>\n";
                    print OUTFILE "<td bgcolor=\"$failcolor\">unmatched</td><td bgcolor=\"$failcolor\">$item</td>\n";
                    print OUTFILE "</tr>\n";
                }
            }
            
            
            elsif ($confcount == 0 && $testcount > 0) { #if only testservers has entries
                # print table for items in testspec only
                foreach my $item (@testservers) {
                    print OUTFILE "<tr>\n";
                    print OUTFILE "<td bgcolor=\"$failcolor\">$item</td><td bgcolor=\"$failcolor\">unmatched</td>\n";
                    print OUTFILE "</tr>\n";
                }
            }
            
            
            elsif ($testcount == 0 && $confcount >0 ) { #if only confservers
                # print table for items in testspec only
                foreach my $item (@confservers) {
                    print OUTFILE "<tr>\n";
                    print OUTFILE "<td bgcolor=\"$failcolor\">$item</td><td bgcolor=\"$failcolor\">unmatched</td>\n";
                    print OUTFILE "</tr>\n";
                }
            }
            print OUTFILE "</table>\n";
            print OUTFILE "<p>\n";
        }
        
        #########################################################################
        #
        # printing the AAA-Generalt results
        #
        #########################################################################
            
            my $checkuser   = $aaa_general_result{'checkusers'};
            my $checktacacs = $aaa_general_result{'checktacacs'};
            my $checkradius = $aaa_general_result{'checkradius'};
            
            if ( $checkuser == 1 || $checkradius == 1 || $checktacacs == 1) {
                print OUTFILE "<H3>General AAA Audit Results</H3><p>\n"; 
            
            
                if ($checkuser == 1) { #printing local user results
                    
                    my $testusers = $aaa_general_result{'testspec'};
                    my $configusers = $aaa_general_result{'actual'};
                    
                    
                    my @common = (); #common usernames
                    my @testuseronly = (); #usernames in testspec only
                    my @configuseronly = (); #usernames in cofig only
                    my @commonprivilege = (); # users with common name & common privs
                    my @uncommonprivilege = (); # users with common name but different privs
                    
                    # find common usernames in testusers and confugusers
                    foreach (keys %$testusers) {
                        push (@common,$_) if exists $$configusers{$_};
                    }
                    
                    # find usernames that are unique to the testpsec
                    foreach (keys %$testusers) {
                        push (@testuseronly, $_) unless exists $$configusers{$_};
                    }
                    # find usernames that are unique to the config
                    foreach (keys %$configusers) {
                        push (@configuseronly, $_) unless exists $$testusers{$_};
                    }
                    
                    
                    # now check privilege levels for common usernames
                    foreach my $line (@common) {
                        if ($$testusers{$line} eq $$configusers{$line}) {
                            push (@commonprivilege,$line);
                        }
                        else {
                            push(@uncommonprivilege,$line);
                        }
                    }
                    #print "common names @common \n";
                    #print "common privs @commonprivilege \n";
                    #print "uncommon privs @uncommonprivilege \n";
                    #print "testspec unique @testuseronly \n";
                    #print "config uniquw @configuseronly \n";
                    
                    print OUTFILE "<H4>1. Local User Accounts Audit Results</H3><p>\n"; 
                    
                    print OUTFILE "<table border=\"1\">\n";
                    print OUTFILE "<colgroup>\n";
                    print OUTFILE "<col width=\"150\">\n";
                    print OUTFILE "<col width=\"150\">\n";
                    print OUTFILE "<col width=\"150\">\n";
                    print OUTFILE "<col width=\"150\">\n";
                    print OUTFILE "</colgroup>\n";
                    print OUTFILE "<tr>\n";
                    print OUTFILE "<th colspan=\"2\">Expected</th><th colspan=\"2\">Actual</th>\n";
                    print OUTFILE "</tr>\n";
                    print OUTFILE "<tr>\n";
                    print OUTFILE "<td>User-Name</td><td>Privilege</td><td>User-Name</td><td>Privilege</td>\n";
                    print OUTFILE "</tr>\n";
                    
                    # print the "good ones"
                    foreach my $line (@commonprivilege) {
                        print OUTFILE "<tr>\n";
                        print OUTFILE "<td bgcolor=\"$passcolor\">$line</td>";
                        print OUTFILE "<td bgcolor=\"$passcolor\">$$testusers{$line}</td>";
                        print OUTFILE "<td bgcolor=\"$passcolor\">$line</td>";
                        print OUTFILE "<td bgcolor=\"$passcolor\">$$configusers{$line}</td>";
                        print OUTFILE "</tr>\n";    
                    }
                    
                    # print common names, uncommon privs
                    foreach my $line (@uncommonprivilege) {
                        print OUTFILE "<tr>\n";
                        print OUTFILE "<td bgcolor=\"$failcolor\">$line</td>";
                        print OUTFILE "<td bgcolor=\"$failcolor\">$$testusers{$line}</td>";
                        print OUTFILE "<td bgcolor=\"$failcolor\">$line</td>";
                        print OUTFILE "<td bgcolor=\"$failcolor\">$$configusers{$line}</td>";
                        print OUTFILE "</tr>\n";    
                    }
                    
                    # print testspec-users only
                    foreach my $line (@testuseronly) {
                        print OUTFILE "<tr>\n";
                        print OUTFILE "<td bgcolor=\"$failcolor\">$line</td>";
                        print OUTFILE "<td bgcolor=\"$failcolor\">$$testusers{$line}</td>";
                        print OUTFILE "<td bgcolor=\"$failcolor\">unmatched</td>";
                        print OUTFILE "<td bgcolor=\"$failcolor\">unmatched</td>";
                        print OUTFILE "</tr>\n";        
                    }
                    # print config-users only
                    foreach my $line (@configuseronly) {
                        print OUTFILE "<tr>\n";
                        print OUTFILE "<td bgcolor=\"$failcolor\">unmatched</td>";
                        print OUTFILE "<td bgcolor=\"$failcolor\">unmatched</td>";
                        print OUTFILE "<td bgcolor=\"$failcolor\">$line</td>";
                        print OUTFILE "<td bgcolor=\"$failcolor\">$$configusers{$line}</td>";
                        print OUTFILE "</tr>\n";        
                    }
                    print OUTFILE "</table>\n";
                    print OUTFILE "<p>\n";
                } # end of user-result output
                
                if ($checktacacs == 1) { #printing tacacs results
                    
                    my $testtacacs = $aaa_general_result{'testtacacs'};
                    my $configtacacs = $aaa_general_result{'configtacacs'};
                    
                    my %tacacsresult = array_comp(@$testtacacs,@$configtacacs);
                    my $tacacsisect = $tacacsresult{'isect'};
                    my $tacacsdifftest = $tacacsresult{'diff_x'};
                    my $tacacsdiffconf = $tacacsresult{'diff_y'};
                    
                    print OUTFILE "<H4>2. TACACS Server Audit Results</H3><p>\n"; 
                    print OUTFILE "<table border=\"1\">\n";
                    print OUTFILE "<colgroup>\n";
                    print OUTFILE "<col width=\"200\">\n";
                    print OUTFILE "<col width=\"200\">\n";
                    print OUTFILE "</colgroup>\n";
                    print OUTFILE "<tr>\n";
                    print OUTFILE "<th>Expected</th><th>Actual</th>\n";
                    
                    # print commons:
                    foreach (@$tacacsisect) {
                        print OUTFILE "<tr>\n";
                        print OUTFILE "<td bgcolor=\"$passcolor\">$_</td><td bgcolor=\"$passcolor\">$_</td>\n";
                        print OUTFILE "</tr>\n";
                    }
                    # print testspec-unique tacacs server
                    foreach (@$tacacsdifftest) {
                        print OUTFILE "<tr>\n";
                        print OUTFILE "<td bgcolor=\"$failcolor\">$_</td><td bgcolor=\"$failcolor\">unmatched</td>\n";
                        print OUTFILE "</tr>\n";
                        
                    }
                    foreach (@$tacacsdiffconf) {
                        print OUTFILE "<tr>\n";
                        print OUTFILE "<td bgcolor=\"$failcolor\">unmatched</td><td bgcolor=\"$failcolor\">$_</td>\n";
                        print OUTFILE "</tr>\n";
                        
                    }
                    
                    
                    print OUTFILE "</tr>\n";
                    print OUTFILE "</table>\n";
                    print OUTFILE "<p>\n";
                } # end of tacacs output
                
                if ($checkradius == 1) { #printing radius results
                    print OUTFILE "<H4>3. RADIUS Server Audit Results</H3><p>\n"; 
                    print OUTFILE "<table border=\"1\">\n";
                    print OUTFILE "<colgroup>\n";
                    print OUTFILE "<col width=\"200\">\n";
                    print OUTFILE "<col width=\"200\">\n";
                    print OUTFILE "</colgroup>\n";
                    print OUTFILE "<tr>\n";
                    print OUTFILE "<th>Expected</th><th>Actual</th>\n";
                    print OUTFILE "</tr>\n";
                    
                    my $testradius = $aaa_general_result{'testradius'};
                    my $configradius = $aaa_general_result{'configradius'};
                    
                    my %radiusresult = array_comp(@$testradius,@$configradius);
                    my $radiusisect = $radiusresult{'isect'};
                    my $radiusdifftest = $radiusresult{'diff_x'};
                    my $radiusdiffconf = $radiusresult{'diff_y'};
                    
                    
                    # print commons:
                    foreach (@$radiusisect) {
                        print OUTFILE "<tr>\n";
                        print OUTFILE "<td bgcolor=\"$passcolor\">$_</td><td bgcolor=\"$passcolor\">$_</td>\n";
                        print OUTFILE "</tr>\n";
                    }
                    # print testspec-unique radius server
                    foreach (@$radiusdifftest) {
                        print OUTFILE "<tr>\n";
                        print OUTFILE "<td bgcolor=\"$failcolor\">$_</td><td bgcolor=\"$failcolor\">unmatched</td>\n";
                        print OUTFILE "</tr>\n";
                        
                    }
                    foreach (@$radiusdiffconf) {
                        print OUTFILE "<tr>\n";
                        print OUTFILE "<td bgcolor=\"$failcolor\">unmatched</td><td bgcolor=\"$failcolor\">$_</td>\n";
                        print OUTFILE "</tr>\n";
                    }
                    
                    print OUTFILE "</table>\n";
                    print OUTFILE "<p>\n";
                } # end of radius-result output
            } # end of general AAA result printing
        
        #########################################################################
        #
        # printing the Layer2 results
        #
        #########################################################################
        
        if ($numberl2if > 0) {        
            print OUTFILE "<H3>Layer 2 Audit Result</H3><p>\n";
            print OUTFILE "<H4>1. Dynamic Trunking Protocol Audit Results</H3><p>\n"; 
            
            print OUTFILE "<table border=\"1\">\n";
            print OUTFILE "<colgroup>\n";
            print OUTFILE "<col width=\"250\">\n";
            print OUTFILE "<col width=\"150\">\n";
            print OUTFILE "</colgroup>\n";
            print OUTFILE "<tr>\n";
            print OUTFILE "<th>Interfacename</th><th>DTP-Status</th>\n";
            print OUTFILE "</tr>\n";
            
            # first printing all interfaces, that have dtp enabled
            while (my ($key, $value) = each(%dtpperifresult)){
                if ($value eq "false") {
                    print OUTFILE "<tr>\n";
                    print OUTFILE "<td bgcolor=$failcolor> $key </td> <td bgcolor=$failcolor>DTP is enabled</td>\n";
                    print OUTFILE "</tr>\n";
                }
            }
            
            # printing all interfaces, that have dtp disabled
            while (my ($key, $value) = each(%dtpperifresult)){
                if ($value eq "true") {
                    print OUTFILE "<tr>\n";
                    print OUTFILE "<td bgcolor=$passcolor> $key </td> <td bgcolor=$passcolor>DTP is disabled</td>\n";
                    print OUTFILE "</tr>\n";
                }
            }
            
            print OUTFILE "</table>\n";
        }
        
        
        #########################################################################
        #
        # Finishing the html file and closing the file
        #
        #########################################################################
        
        print OUTFILE "</body>\n";
        print OUTFILE "</html>\n";
        close(OUTFILE);
            

        
    }
}










#### looping through tests by tests
if ($resultbytest==1) {
    #print "sorting result by test\n";
}



print "\n";
print "***************************************************************\n";
print "*                                                             *\n";
print "*                           Finished Audit                    *\n";
print "*                    thanks for your patience                 *\n";
print "*                                                             *\n";
print "***************************************************************\n";

# -> end of "main" 













# ********************************************
# *   some handy subds below this point!     *
# ********************************************


sub hash_comp(\%;\%) {
    my $X = $_[0]; # first passed array
    my $Y = $_[1]; # second passed array
    my @common_keys;
    
    my @isect; # has common keys and equal values
    my @part_isect; # has common keys but unequal values
    my @X_only;
    my @Y_only;
    
    # find common keys
    foreach (keys %$X) {push (@common_keys,$_) if exists $$Y{$_};}
    
    #find keys unique to X;
    foreach (keys %$X) {push (@X_only,$_) unless exists $$Y{$_};}
    
    #find keys unique to Y;
    foreach (keys %$Y) {push (@Y_only,$_) unless exists $$X{$_};}
    
    # check for values of common keys
    foreach (@common_keys) {
        if ($$Y{$_} eq $$X{$_}) {push (@isect,$_);}
        else {push (@part_isect,$_);}
    }
    
    my %returnhash = ('diff_x' => [@X_only],
                      'diff_y' => [@Y_only],
                      'isect1' => [@isect],
                      'isect2' => [@part_isect]
                      ); 
    
    print "nothing\n";
    
    return %returnhash;
}


sub array_comp(\@;\@) { # @X;@Y -> note, the order is important!
    
    my $X = $_[0]; # first passed array
    my $Y = $_[1]; # second passed array
    
    my %union; # all elements from X and Y
    my %isect; # only elements which are in (A && B)
    my %seen_X; # elements seen in X
    my %seen_Y; # elements seen in Y
    my @diff_X; # holds unique elements from X
    my @diff_Y; # holds unique elements from Y
    
    # find unione & intersection
    foreach my $temp (@$X) {
        chomp $temp;
        $union{$temp} = 1;
    }
    foreach my $temp (@$Y) {
        chomp $temp;
        if ($union{$temp}) {
            $isect{$temp}=1;
        }
        $union{$temp}=1;
    }
    my @union = keys %union;
    my @isect = keys %isect;

    # find differences (unique elements in X):
    foreach my $temp (@$X) {
        chomp $temp;
        $seen_X{$temp}=1;
    }
    foreach my $temp (@$Y) {
        chomp $temp;
        unless ($seen_X{$temp}) {
            push (@diff_Y,$temp);
        }
    }
    
    # find differences (unique elements in Y):
    foreach my $temp (@$Y) {
        chomp $temp;
        $seen_Y{$temp}=1;
    }
    foreach my $temp (@$X) {
        chomp $temp;
        unless ($seen_Y{$temp}) {
            push (@diff_X,$temp);
        }
    }
    
    my %returnvalue = ('diff_x' => [@diff_X],
                       'diff_y' => [@diff_Y],
                       'union'  => [@union],
                       'isect'  => [@isect]
                      );
    return %returnvalue;
}
    
